import java.util.Vector;

import javax.swing.table.AbstractTableModel;


public class ReqTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int MSG_INDEX = 0;
	public static final int URL_INDEX = 1;
	
	protected Vector<ReqDataRow> dataVector = new Vector<ReqDataRow>();
	
    protected String[] columnNames = {
    		"Message",
    		"Requested URL"
    };
    
    public void addRow(String msg, String url){
    	dataVector.addElement(new ReqDataRow(msg, url));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        ReqDataRow record = (ReqDataRow)dataVector.get(row);
        switch (col) {
        	case MSG_INDEX:
        		return record.Method;
        	case URL_INDEX:
	        	 return record.URL;

            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}
}