import java.util.Vector;

import javax.swing.table.AbstractTableModel;


public class CertTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int S_INDEX = 0;
	public static final int I_INDEX = 1;
	public static final int A_INDEX = 2;
	
	protected Vector<CertDataRow> dataVector = new Vector<CertDataRow>();
	
    protected String[] columnNames = {
    		"Serial Number",
    		"Issuer Name", 
    		"Subject Name" 
    };
    
    public void addRow(String s, String i, String a){
    	dataVector.addElement(new CertDataRow(s, i, a));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        CertDataRow record = (CertDataRow)dataVector.get(row);
        switch (col) {
        	case S_INDEX:
        		return record.Serial;
        	case I_INDEX:
	        	 return record.Issuer;
            case A_INDEX:
               return record.Subject;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}
}