

import java.awt.EventQueue;
import java.awt.Rectangle;

import javax.swing.JDialog;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.Dimension;
import java.net.URL;

import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.JTextArea;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.plaf.basic.BasicTabbedPaneUI;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.*;
import SecureBlackbox.PGP.*;
import SecureBlackbox.PGPMIME.*;
import SecureBlackbox.SMIME.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.SwingConstants;

import org.freepascal.rtl.TObject;

public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private JPanel tsSelectAction;
	private JRadioButton rbSMimeVerify;
	private JRadioButton rbSMimeDecrypt;
	private JRadioButton rbSMimeEncrypt;
	private JRadioButton rbSMimeSign;
	private JPanel tsSelectCertificate;
	private JPanel tsAlgorithm;
	private final ButtonGroup buttonGroup_1 = new ButtonGroup();
	private JPanel tsSignAlgorithm;
	private final ButtonGroup buttonGroup_2 = new ButtonGroup();
	private JRadioButton rbMD5;
	private JRadioButton rbSHA1;
	private JPanel tsSelectFiles;
	private JTextField edInputFile;
	private JTextField edOutputFile;
	private JTextArea mmInfo;
	private JPanel tsSelectKeys;
  
	private TElMemoryCertStorage memoryCertStorage = null;
	private JPanel tsSelectKey;
	private JButton btnBack;
	private JPanel tsCheckData;
	private JButton btnNext;
	private JLabel label4;
	private JButton btnDoIt;
	private JRadioButton rbAES_256;
	private JRadioButton rbAES_128;
	private JRadioButton rbRC2;
	private JRadioButton rbRC4_40;
	private JRadioButton rbRC4_128;
	private JRadioButton rbTripleDES;
	private JList<String> lbxCertificates;
	private JButton sbInputFile;
	private JButton sbOutputFile;
	private JButton btnCancel;
	private JLabel lblUsePgpmimeSecurity;
	private JRadioButton rbPGPMimeSign;
	private JRadioButton rbPGPMimeEncrypt;
	private JRadioButton rbPGPMimeDecrypt;
	private JRadioButton rbPGPMimeVerify;
	private JLabel lbSelectCertificates;
	private JLabel lbInfo;
	private JRadioButton rbDES;
	private JRadioButton rbAES_192;
	private JLabel lbKeyring;
	private JTextField edKeyring;
	private JTree tvKeys;
	private JTextArea mmResult;
	
	// new
	
	private final String cDemoVersion = "2011.05.31";

	private final String cXMailerDemoFieldValue = ("EldoS ElMime Demos, version: " + (cDemoVersion + (" ( " + (SBMIME.cXMailerDefaultFieldValue + " )"))));

	private final String sLF = "" + "\r\n";
	private final short ACTION_UNKNOWN = 0;
	private final short ACTION_SMIME_ENCRYPT = 1;
	private final short ACTION_SMIME_SIGN = 2;
	private final short ACTION_SMIME_DECRYPT = 3;
	private final short ACTION_SMIME_VERIFY = 4;
	private final short ACTION_PGPMIME_ENCRYPT = 5;
	private final short ACTION_PGPMIME_SIGN = 6;
	private final short ACTION_PGPMIME_DECRYPT = 7;

	private final short ACTION_PGPMIME_VERIFY = 8;
	private final short PAGE_DEFAULT = 0;
	private final short PAGE_SELECT_ACTION = 1;
	private final short PAGE_SELECT_FILES = 2;
	private final short PAGE_SELECT_CERTIFICATES = 3;
	private final short PAGE_SELECT_ALGORITHM = 4;
	private final short PAGE_SELECT_KEYS = 5;
	private final short PAGE_CHECK_DATA = 6;

	private final short PAGE_PROCESS = 7;
	private short Action;

	private short CurrentPage;

	private TElMemoryCertStorage MemoryCertStorage;
	private TElPGPKeyring Keyring;
	private TElPGPKeyring SecretRing;
	private TElPGPKeyring PublicRing;	
	private JLabel lbOutputFile;
	private JLabel lbInputFile;
	private JLabel lbSelectKey;
	private JLabel lbResult;
	private JPanel tsResult;
	private final String vbCrLf = "\r\n";
	private DefaultMutableTreeNode rootNode;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("Messages Demo");
		setBounds(100, 100, 507, 433);
		getContentPane().setLayout(null);
		
		rootNode = new DefaultMutableTreeNode("");
						
		JPanel panel = new JPanel();
		panel.setBounds(0, 377, 499, 29);
		panel.setPreferredSize(new Dimension(10, 40));
		getContentPane().add(panel);
		panel.setLayout(null);
		
		btnBack = new JButton("< Back");
		btnBack.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				backClick();
			}
		});
		btnBack.setBounds(200, 5, 77, 23);
		panel.add(btnBack);
		
		btnNext = new JButton("Next >");
		btnNext.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				nextClick();
			}
		});
		btnNext.setBounds(287, 5, 100, 23);
		panel.add(btnNext);
		
		btnCancel = new JButton("Cancel");
		btnCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
				System.exit(0);
			}
		});
		btnCancel.setBounds(396, 5, 77, 23);
		panel.add(btnCancel);
		
		JLabel lblImg = new JLabel();
		lblImg.setVerticalAlignment(SwingConstants.TOP);
		lblImg.setBounds(0, 0, 150, 374);
		lblImg.setIcon(getIcon("west"));
		lblImg.setPreferredSize(new Dimension(150, 10));
		getContentPane().add(lblImg);
		
		PageControl = new JTabbedPane(JTabbedPane.TOP);
		PageControl.setUI(new BasicTabbedPaneUI() {  
            protected int calculateTabAreaHeight(int tabPlacement, int horizRunCount, int maxTabHeight) {  
                    return 0;  
            }  
        });
		PageControl.setBounds(150, 0, 349, 374);
		getContentPane().add(PageControl);
		
		tsCheckData = new JPanel();
		PageControl.addTab("New tab", null, tsCheckData, null);
		tsCheckData.setVisible(false);
		tsCheckData.setLayout(null);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 77, 329, 143);
		tsCheckData.add(scrollPane_1);
		
		mmInfo = new JTextArea();
		scrollPane_1.setViewportView(mmInfo);
		
		btnDoIt = new JButton("Encrypt");
		btnDoIt.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				NextPage();
			}
		});
		btnDoIt.setBounds(131, 231, 91, 23);
		tsCheckData.add(btnDoIt);
		
		lbInfo = new JLabel("<html><body></center>Ready to start encryption. Please check all the parameters to be valid</center></body></html>");
		lbInfo.setBounds(10, 11, 329, 59);
		tsCheckData.add(lbInfo);
		
		tsSelectAction = new JPanel();
		PageControl.addTab("New tab", null, tsSelectAction, null);
		tsSelectAction.setVisible(false);
		tsSelectAction.setLayout(null);
		
		JLabel lblWhatKindOf = new JLabel("What kind of action would you like to perform?");
		lblWhatKindOf.setBounds(10, 29, 341, 14);
		tsSelectAction.add(lblWhatKindOf);
		
		rbSMimeSign = new JRadioButton("Digitally sign message");
		buttonGroup_3.add(rbSMimeSign);
		rbSMimeSign.setSelected(true);
		rbSMimeSign.setBounds(41, 67, 184, 23);
		tsSelectAction.add(rbSMimeSign);
		
		rbSMimeEncrypt = new JRadioButton("Encrypt message");
		buttonGroup_3.add(rbSMimeEncrypt);
		rbSMimeEncrypt.setBounds(41, 93, 127, 23);
		tsSelectAction.add(rbSMimeEncrypt);
		
		rbSMimeDecrypt = new JRadioButton("Decrypt message");
		buttonGroup_3.add(rbSMimeDecrypt);
		rbSMimeDecrypt.setBounds(41, 119, 133, 23);
		tsSelectAction.add(rbSMimeDecrypt);
		
		rbSMimeVerify = new JRadioButton("Verify digital signature");
		buttonGroup_3.add(rbSMimeVerify);
		rbSMimeVerify.setBounds(41, 145, 184, 23);
		tsSelectAction.add(rbSMimeVerify);
		
		JLabel lblUseSmimeSecurity = new JLabel("Use S/Mime security:");
		lblUseSmimeSecurity.setBounds(20, 50, 205, 14);
		tsSelectAction.add(lblUseSmimeSecurity);
		
		lblUsePgpmimeSecurity = new JLabel("Use PGP/Mime security:");
		lblUsePgpmimeSecurity.setBounds(20, 175, 180, 14);
		tsSelectAction.add(lblUsePgpmimeSecurity);
		
		rbPGPMimeSign = new JRadioButton("Digitally sign message");
		buttonGroup_3.add(rbPGPMimeSign);
		rbPGPMimeSign.setBounds(41, 195, 184, 23);
		tsSelectAction.add(rbPGPMimeSign);
		
		rbPGPMimeEncrypt = new JRadioButton("Encrypt message");
		buttonGroup_3.add(rbPGPMimeEncrypt);
		rbPGPMimeEncrypt.setBounds(41, 221, 127, 23);
		tsSelectAction.add(rbPGPMimeEncrypt);
		
		rbPGPMimeDecrypt = new JRadioButton("Decrypt message");
		buttonGroup_3.add(rbPGPMimeDecrypt);
		rbPGPMimeDecrypt.setBounds(41, 247, 159, 23);
		tsSelectAction.add(rbPGPMimeDecrypt);
		
		rbPGPMimeVerify = new JRadioButton("Verify digital signature");
		buttonGroup_3.add(rbPGPMimeVerify);
		rbPGPMimeVerify.setBounds(41, 273, 184, 23);
		tsSelectAction.add(rbPGPMimeVerify);
		
		tsAlgorithm = new JPanel();
		PageControl.addTab("New tab", null, tsAlgorithm, null);
		tsAlgorithm.setVisible(false);
		tsAlgorithm.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("<html><body>Please chhose encryption algorithm which should be used to encrypt data</body></html>");
		lblNewLabel.setBounds(10, 11, 329, 51);
		tsAlgorithm.add(lblNewLabel);
		
		rbTripleDES = new JRadioButton("Triple DES (168 bits)");
		rbTripleDES.setSelected(true);
		buttonGroup_1.add(rbTripleDES);
		rbTripleDES.setBounds(new Rectangle(48, 97, 200, 20));
		tsAlgorithm.add(rbTripleDES);
		
		rbRC4_128 = new JRadioButton("RC 4 (128 bits)");
		buttonGroup_1.add(rbRC4_128);
		rbRC4_128.setBounds(new Rectangle(48, 168, 200, 20));
		tsAlgorithm.add(rbRC4_128);
		
		rbRC4_40 = new JRadioButton("RC 4 (40 bits)");
		buttonGroup_1.add(rbRC4_40);
		rbRC4_40.setBounds(new Rectangle(48, 143, 200, 20));
		tsAlgorithm.add(rbRC4_40);
		
		rbRC2 = new JRadioButton("RC 2 (128 bits)");
		buttonGroup_1.add(rbRC2);
		rbRC2.setBounds(new Rectangle(48, 120, 200, 20));
		tsAlgorithm.add(rbRC2);
		
		rbAES_128 = new JRadioButton("AES (128 bits)");
		buttonGroup_1.add(rbAES_128);
		rbAES_128.setBounds(new Rectangle(48, 191, 200, 20));
		tsAlgorithm.add(rbAES_128);
		
		rbAES_256 = new JRadioButton("AES (256 bits)");
		buttonGroup_1.add(rbAES_256);
		rbAES_256.setBounds(new Rectangle(48, 237, 200, 20));
		tsAlgorithm.add(rbAES_256);
		
		rbDES = new JRadioButton("DES (56 bits)");
		rbDES.setBounds(new Rectangle(48, 74, 200, 20));
		tsAlgorithm.add(rbDES);
		
		rbAES_192 = new JRadioButton("AES (192 bits)");
		rbAES_192.setBounds(new Rectangle(48, 214, 200, 20));
		tsAlgorithm.add(rbAES_192);
		
		tsSelectKeys = new JPanel();
		PageControl.addTab("New tab", null, tsSelectKeys, null);
		tsSelectKeys.setVisible(false);
		tsSelectKeys.setLayout(null);
		
		JScrollPane scrollPane_2 = new JScrollPane();
		scrollPane_2.setBounds(10, 79, 329, 190);
		tsSelectKeys.add(scrollPane_2);
		tvKeys = new JTree(new DefaultTreeModel(rootNode));
		tvKeys.setRootVisible(false);
		tvKeys.setShowsRootHandles(true); 		
		scrollPane_2.setViewportView(tvKeys);
		
		JButton btnAddKey = new JButton("Add key");
		btnAddKey.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addTreeKeyClick();
			}
		});
		btnAddKey.setBounds(45, 284, 102, 23);
		tsSelectKeys.add(btnAddKey);
		
		JButton btnRemoveKey = new JButton("Remove key");
		btnRemoveKey.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeTreeKeyClick();
			}
		});
		btnRemoveKey.setBounds(157, 284, 128, 23);
		tsSelectKeys.add(btnRemoveKey);
		
		lbSelectKey = new JLabel("<html><body><center>Please choose PGP keys, which may be used to decrypt encrypted message</center></body></html>");
		lbSelectKey.setBounds(10, 11, 329, 57);
		tsSelectKeys.add(lbSelectKey);
		
		tsSignAlgorithm = new JPanel();
		PageControl.addTab("New tab", null, tsSignAlgorithm, null);
		tsSignAlgorithm.setVisible(false);
		tsSignAlgorithm.setLayout(null);
		
		label4 = new JLabel("<html><body>Please choose hash function which should be used to calculate message digest on input data</body></html>");
		label4.setBounds(10, 11, 329, 49);
		tsSignAlgorithm.add(label4);
		
		rbMD5 = new JRadioButton("MD5");
		buttonGroup_2.add(rbMD5);
		rbMD5.setSelected(true);
		rbMD5.setBounds(60, 67, 109, 23);
		tsSignAlgorithm.add(rbMD5);
		
		rbSHA1 = new JRadioButton("SHA1");
		buttonGroup_2.add(rbSHA1);
		rbSHA1.setBounds(60, 93, 109, 23);
		tsSignAlgorithm.add(rbSHA1);
		
		tsSelectCertificate = new JPanel();
		PageControl.addTab("New tab", null, tsSelectCertificate, null);
		tsSelectCertificate.setVisible(false);
		tsSelectCertificate.setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 71, 329, 161);
		tsSelectCertificate.add(scrollPane);
		
		lbxCertificates = new JList<String>(new DefaultListModel<String>());
		scrollPane.setViewportView(lbxCertificates);
		
		JButton btnAddCertificate = new JButton("Add certificate");
		btnAddCertificate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addCertificateClick();
			}
		});
		btnAddCertificate.setBounds(10, 246, 155, 23);
		tsSelectCertificate.add(btnAddCertificate);
		
		JButton btnRemoveCertificate = new JButton("Remove certificate");
		btnRemoveCertificate.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				memoryCertStorage.remove(lbxCertificates.getSelectedIndex());
				RefreshCertificateListbox();				
			}
		});
		btnRemoveCertificate.setBounds(175, 246, 164, 23);
		tsSelectCertificate.add(btnRemoveCertificate);
		
		lbSelectCertificates = new JLabel("<html><body><center>Please choose certificates, which may be used to decrypt encrypted message</center></body></html>");
		lbSelectCertificates.setBounds(10, 11, 329, 53);
		tsSelectCertificate.add(lbSelectCertificates);
		
		tsResult = new JPanel();
		PageControl.addTab("New tab", null, tsResult, null);
		tsResult.setLayout(null);
		
		lbResult = new JLabel("Encryption results:");
		lbResult.setBounds(30, 35, 157, 14);
		tsResult.add(lbResult);
		
		JScrollPane scrollPane_3 = new JScrollPane();
		scrollPane_3.setBounds(10, 60, 329, 208);
		tsResult.add(scrollPane_3);
		
		mmResult = new JTextArea();
		mmResult.setLineWrap(true);
		mmResult.setWrapStyleWord(true);
		scrollPane_3.setViewportView(mmResult);
		
		tsSelectKey = new JPanel();
		PageControl.addTab("New tab", null, tsSelectKey, null);
		tsSelectKey.setVisible(false);
		tsSelectKey.setLayout(null);
		
		lbSelectKey = new JLabel("<html><body>Please choose PGP key, which should be used to encrypt message</body></html>");
		lbSelectKey.setBounds(10, 11, 329, 47);
		tsSelectKey.add(lbSelectKey);
		
		lbKeyring = new JLabel("Public keyring:");
		lbKeyring.setBounds(29, 87, 136, 14);
		tsSelectKey.add(lbKeyring);
		
		edKeyring = new JTextField();
		edKeyring.setBounds(29, 105, 250, 20);
		tsSelectKey.add(edKeyring);
		edKeyring.setColumns(10);
		
		JButton btnBrowse = new JButton("Browse");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				browsePublicKeyringClick();
			}
		});
		btnBrowse.setBounds(289, 104, 29, 23);
		tsSelectKey.add(btnBrowse);
		
		tsSelectFiles = new JPanel();
		PageControl.addTab("New tab", null, tsSelectFiles, null);
		tsSelectFiles.setVisible(false);
		tsSelectFiles.setLayout(null);
		
		lbInputFile = new JLabel("Input file");
		lbInputFile.setBounds(10, 98, 207, 14);
		tsSelectFiles.add(lbInputFile);
		
		edInputFile = new JTextField();
		edInputFile.setBounds(10, 122, 272, 20);
		tsSelectFiles.add(edInputFile);
		edInputFile.setColumns(10);
		
		sbInputFile = new JButton("...");
		sbInputFile.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				edInputFile.setText(getOpenFileName());
			}
		});
		sbInputFile.setBounds(292, 121, 47, 23);
		tsSelectFiles.add(sbInputFile);
		
		lbOutputFile = new JLabel("Output file");
		lbOutputFile.setBounds(10, 166, 272, 14);
		tsSelectFiles.add(lbOutputFile);
		
		edOutputFile = new JTextField();
		edOutputFile.setBounds(10, 191, 272, 20);
		tsSelectFiles.add(edOutputFile);
		edOutputFile.setColumns(10);
		
		sbOutputFile = new JButton("...");
		sbOutputFile.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				edOutputFile.setText(getSaveFileName());
			}
		});
		sbOutputFile.setBounds(292, 191, 47, 23);
		tsSelectFiles.add(sbOutputFile);
		
		lbSelectFiles = new JLabel("<html><body><center>Please select message file to encrypt and file where to write encrypted data</center></body></html>");
		lbSelectFiles.setBounds(10, 11, 324, 80);
		tsSelectFiles.add(lbSelectFiles);
		
		init();
	}
	
	protected void removeTreeKeyClick() {
		Object tag = getSelectedTreeNodeTag();
		
		if (tag == null) return;
		
		if ((tag instanceof TElPGPPublicKey)) {
			TElPGPPublicKey Key = (TElPGPPublicKey)tag;
			if ((((Key.getSecretKey()) != null))) {
				Keyring.removeSecretKey(Key.getSecretKey());
			} else {
				Keyring.removePublicKey(Key, true);
			}
		} else if ((tag instanceof TElPGPSecretKey)) {
			Keyring.removeSecretKey((TElPGPSecretKey)tag);
		}

		updateKeysList();
	}

	private void updateKeysList()
	{
		String s = null;
		clearTree();
		
		if ((Action == ACTION_PGPMIME_DECRYPT)) {
			int i = 0;
			for (i = 0; i <= Keyring.getSecretCount() - 1; i++) {
				s = GetPublicKeyNames(Keyring.getSecretKeys(i).getPublicKey());
				if ((!isNullOrEmpty(s))) {
					s = s + " (" + SBPGPUtils.keyID2Str(Keyring.getSecretKeys(i).keyID(), true) + ")";
				} else {
					s = SBPGPUtils.keyID2Str(Keyring.getSecretKeys(i).keyID(), true);
				}
				if ((isNullOrEmpty(s))) {
					s = "<unknown>";
				}

				DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(s);
				newNode.setUserObject(new UserNode(s, Keyring.getSecretKeys(i)));				
				rootNode.add(newNode);
			}
		}

		if (Action == ACTION_PGPMIME_VERIFY) {
			int i = 0;
			for (i = 0; i <= Keyring.getPublicCount() - 1; i++) {
				s = GetPublicKeyNames(Keyring.getPublicKeys(i));
				if ((!isNullOrEmpty(s))) {
					s = s + " (" + SBPGPUtils.keyID2Str(Keyring.getPublicKeys(i).keyID(), true) + ")";
				} else {
					s = SBPGPUtils.keyID2Str(Keyring.getPublicKeys(i).keyID(), true);
				}

				if (isNullOrEmpty(s)) {
					s = "<unknown>";
				}

				DefaultMutableTreeNode newNode = new DefaultMutableTreeNode(s);
				newNode.setUserObject(new UserNode(s, Keyring.getSecretKeys(i)));				
				rootNode.add(newNode);
			}
		}
	}
	
	private Object getSelectedTreeNodeTag() {
	    TreePath[] paths = tvKeys.getSelectionPaths();

	    if (paths.length > 0)
	    	return getFirstNode(paths).getTag();
	    
		return null;
	}

	UserNode getFirstNode(TreePath[] paths){
		return (UserNode)((DefaultMutableTreeNode)paths[0].getLastPathComponent()).getUserObject();
	}
	
	protected void addTreeKeyClick() {
		String fileName = getOpenKeyringFile();
		if (fileName.length() > 0) {
			TElPGPKeyring TempKeyring = new TElPGPKeyring(null);
			TempKeyring.load(fileName, "", true);
			if (((Action == ACTION_PGPMIME_VERIFY) && (TempKeyring.getPublicCount() > 0))) {
				TempKeyring.exportTo(Keyring);
			}
			if (((Action == ACTION_PGPMIME_DECRYPT) && (TempKeyring.getSecretCount() > 0))) {
				TempKeyring.exportTo(Keyring);
			}

			updateKeysList();
		}
	}

	protected void browsePublicKeyringClick() {
		String fileName = getOpenKeyringFile();
		if (fileName.length() > 0) {
			TElFileStream F = new TElFileStream(fileName, "r", true);
			try {
				if ((Action == ACTION_PGPMIME_ENCRYPT)) {
					PublicRing.load(F, null, true);
				} else if ((Action == ACTION_PGPMIME_SIGN)) {
					SecretRing.load(F, null, true);
				}
			} catch(Exception ex) {
				edKeyring.setText("");
				return;
			} finally {
				F.Free();
			}

			edKeyring.setText(fileName);
		}
	}

	private String getOpenKeyringFile() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PGP Keyring files", "asc", "pkr", "skr", "gpg", "pgp");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	protected void addCertificateClick() {
		String fileName = openCertFileName();
		if (fileName.length() > 0)
		{
			boolean KeyLoaded = false;
			int index = 0;

			TElFileStream F = new TElFileStream(fileName, "r", true);
			int len =  (int)F.getLength();
			byte[] Buf = new byte[len];
			F.read(Buf, 0, len);
			F.Free();

			int Res = 0;
			TElX509Certificate Cert = new TElX509Certificate(null);
			int FilterIndex = getFilterIndex(fileName);
			if ((FilterIndex  == 3)) {
				Res = Cert.loadFromBufferPFX(Buf, requestPassphrase());
			} else if ((FilterIndex == 1)) {
				Res = Cert.loadFromBufferPEM(Buf, "");
			} else if ((FilterIndex == 2)) {
				Cert.loadFromBuffer(Buf);
			} else {
				Res = -1;
			}

			if (((Res != 0) || (Cert.getCertificateSize() == 0))) {
				showErrorMessage("Error loading the certificate", "Secure Mail");
				return;
			}

			if (((Action == ACTION_SMIME_DECRYPT) || (Action == ACTION_SMIME_SIGN))) {
				TSBInteger Sz = new TSBInteger();
				Buf = null;
				Cert.saveKeyToBuffer(Buf, Sz);
				if ((Sz.value == 0)) {
					fileName = getOpenPrivKeyFile();
					if (fileName.length() > 0) {
						F = new TElFileStream(fileName, "r", true);
						len = (int)F.getLength();
						Buf = new byte[len];
						F.read(Buf, 0, len);
						F.Free();

						FilterIndex = getFilterIndex(fileName);
						if ((FilterIndex == 1)) {
							Cert.loadKeyFromBufferPEM(Buf, requestPassphrase());
						} else {
							Cert.loadKeyFromBuffer(Buf);
						}

						KeyLoaded = true;
					}
				} else {
					KeyLoaded = true;
				}
			}

			// certificate e-mail in UTF8
			String sFrom = GetOIDValue(Cert.getSubjectRDN(), SBConstants.SB_CERT_OID_EMAIL.Data);
			if ((isNullOrEmpty(sFrom))) {
				index = Cert.getExtensions().getSubjectAlternativeName().getContent().findNameByType(TSBGeneralName.gnRFC822Name, 0);
				if ((index >= 0)) {
					sFrom = Cert.getExtensions().getSubjectAlternativeName().getContent().getName(index).getRFC822Name();
				} else {
					showErrorMessage("Warning: Certificate does not contain e-mail address.", "Secure Mail");
				}
			}

			if (((Action == ACTION_SMIME_DECRYPT) && !KeyLoaded)) {
				showErrorMessage("Private key was not loaded, certificate ignored", "Secure Mail");
			} else {
				MemoryCertStorage.add(Cert, true);
				updateCertificatesList();
			}		
		}
	}

	private void updateCertificatesList()
	{
		clearCertList();
		
		String s = null;
		int i = 0;
		for (i = 0; i <= MemoryCertStorage.getCount() - 1; i++) {
			s = GetOIDValue(MemoryCertStorage.getCertificate(i).getSubjectRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data);
			if ((isNullOrEmpty(s))) {
				s = GetOIDValue(MemoryCertStorage.getCertificate(i).getSubjectRDN(), SBConstants.SB_CERT_OID_ORGANIZATION.Data);
			}
			if ((isNullOrEmpty(s))) {
				s = "<unknown>";
			}

			addListItem(lbxCertificates, s);
		}
	}
	
	private void clearCertList() {
		((DefaultListModel<String>)lbxCertificates.getModel()).removeAllElements();
	}

	public String GetOIDValue(TElRelativeDistinguishedName RDN, byte[] S)
	{
		String t = "";
		int iCount = RDN.getCount();
		int i = 0;
		for (i = 0; i <= iCount - 1; i++) {
			if ((SBUtils.compareContent(RDN.getOID(i), S))) {
				if ((!isNullOrEmpty(t))) {
					t = t + " / ";
				}

				t = t + SBStrUtils.utf8ToStr(RDN.getValue(i));
			}
		}

		return t;
	}

	private void RefreshCertificateListbox()
	{
		((DefaultListModel<String>)lbxCertificates.getModel()).removeAllElements();
		
		for (int i = 0; i < memoryCertStorage.getCount(); i++)
			addListItem(lbxCertificates, memoryCertStorage.getCertificate(i).getSubjectName().CommonName);
	}
	
	private void addListItem(JList<String> list, String m) {
		DefaultListModel<String> model = ((DefaultListModel<String>)list.getModel());
		model.add(model.size(), m);
	}
	
	private int getFilterIndex(String certFileName) {
		String ext = extension(certFileName).toLowerCase();
		if (ext.compareTo("pem") == 0) return 1;
		if (ext.compareTo("der") == 0) return 2;
		return 3;
	}

	public String extension(String fullPath) {
	    int dot = fullPath.lastIndexOf(".");
	    return fullPath.substring(dot + 1);
	}
	
	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}

	protected String getSaveFileName() {
		JFileChooser fc = new JFileChooser();
			    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	protected String getOpenFileName() {
		JFileChooser fc = new JFileChooser();
			    
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private String openCertFileName() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select certificate file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER | PFX )-encoded certificate", "pem", "cer", "pfx");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private String getOpenPrivKeyFile() {
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select the corresponding private key file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER )-encoded certificate", "pem", "key");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}	

	String openDecCertFileName(){
		JFileChooser fc = new JFileChooser();
		fc.setDialogTitle("Select the corresponding private key file");

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER )-encoded certificate", "pem", "der");
		fc.setFileFilter(filter);

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private String requestPassphrase() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password:", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}
	
	protected void backClick() {
		back();
	}

	protected void nextClick() {
		NextPage();
	}

	private void back()
	{
		short NewPage = 0;
		if ((PageControl.getSelectedIndex() < 0)) {
			SetPage(PAGE_DEFAULT);
			return;
		}

		NewPage = PAGE_DEFAULT;
		switch ((CurrentPage)) {
			case PAGE_SELECT_FILES:
				NewPage = PAGE_SELECT_ACTION;
				break;
			case PAGE_SELECT_CERTIFICATES:
				NewPage = PAGE_SELECT_FILES;
				break;
			case PAGE_SELECT_ALGORITHM:
				NewPage = PAGE_SELECT_CERTIFICATES;
				break;
			case PAGE_SELECT_KEYS:
				NewPage = PAGE_SELECT_FILES;
				break;
			case PAGE_CHECK_DATA:
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
					case ACTION_SMIME_SIGN:
						NewPage = PAGE_SELECT_ALGORITHM;
						break;
					case ACTION_SMIME_DECRYPT:
					case ACTION_SMIME_VERIFY:
						NewPage = PAGE_SELECT_CERTIFICATES;
						break;
					default:
						NewPage = PAGE_SELECT_KEYS;
						break;
				}
				break;
			case PAGE_PROCESS:
				NewPage = PAGE_CHECK_DATA;
				break;
		}

		SetPage(NewPage);
	}
	
	private void NextPage()
	{
		if ((PageControl.getSelectedIndex() < 0)) {
			SetPage(PAGE_DEFAULT);
			return;
		}


		if ((CurrentPage == PAGE_SELECT_ACTION) && ((rbSMimeEncrypt.isSelected() && (Action != ACTION_SMIME_ENCRYPT)) || (rbSMimeDecrypt.isSelected() && (Action != ACTION_SMIME_DECRYPT)) || (rbSMimeSign.isSelected() && (Action != ACTION_SMIME_SIGN)) || (rbSMimeVerify.isSelected() && (Action != ACTION_SMIME_VERIFY)) || (rbPGPMimeEncrypt.isSelected() && (Action != ACTION_PGPMIME_ENCRYPT)) || (rbPGPMimeDecrypt.isSelected() && (Action != ACTION_PGPMIME_DECRYPT)) || (rbPGPMimeSign.isSelected() && (Action != ACTION_PGPMIME_SIGN)) || (rbPGPMimeVerify.isSelected() && (Action != ACTION_PGPMIME_VERIFY)))) {
			if (rbSMimeEncrypt.isSelected()) {
				Action = ACTION_SMIME_ENCRYPT;
			} else if (rbSMimeDecrypt.isSelected()) {
				Action = ACTION_SMIME_DECRYPT;
			} else if (rbSMimeSign.isSelected()) {
				Action = ACTION_SMIME_SIGN;
			} else if (rbSMimeVerify.isSelected()) {
				Action = ACTION_SMIME_VERIFY;
			} else if (rbPGPMimeEncrypt.isSelected()) {
				Action = ACTION_PGPMIME_ENCRYPT;
			} else if (rbPGPMimeDecrypt.isSelected()) {
				Action = ACTION_PGPMIME_DECRYPT;
			} else if (rbPGPMimeSign.isSelected()) {
				Action = ACTION_PGPMIME_SIGN;
			} else if (rbPGPMimeVerify.isSelected()) {
				Action = ACTION_PGPMIME_VERIFY;
			} else {
				Action = ACTION_UNKNOWN;
			}

			ClearData();
		}

		switch ((Action)) {
			case ACTION_SMIME_ENCRYPT:
				SMimeEncryptNext();
				break;
			case ACTION_SMIME_DECRYPT:
				SMimeDecryptNext();
				break;
			case ACTION_SMIME_SIGN:
				SMimeSignNext();
				break;
			case ACTION_SMIME_VERIFY:
				SMimeVerifyNext();
				break;
			case ACTION_PGPMIME_ENCRYPT:
				PGPEncryptNext();
				break;
			case ACTION_PGPMIME_DECRYPT:
				PGPDecryptNext();
				break;
			case ACTION_PGPMIME_SIGN:
				PGPSignNext();
				break;
			case ACTION_PGPMIME_VERIFY:
				PGPVerifyNext();
				break;
			default:
				SetPage(PAGE_DEFAULT);
				break;
		}
	}
	
	private void ClearData()
	{
		edInputFile.setText(""); 
		edOutputFile.setText("");

		MemoryCertStorage.clear();
		((DefaultListModel<String>)lbxCertificates.getModel()).clear();

		rbTripleDES.setSelected(true);
		rbSHA1.setSelected(true);

		PublicRing.clear();
		SecretRing.clear();
		Keyring.clear();
		edKeyring.setText("");
		clearTree();

		mmInfo.setText("");
		mmResult.setText("");
	}

	private void clearTree() {
		rootNode.removeAllChildren();
	}

	private void PGPVerifyNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if ((isNullOrEmpty(edInputFile.getText()))) {
					showErrorMessage("You must select input file", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_KEYS;
				}

				break;
			case PAGE_SELECT_KEYS:
				NextPage = PAGE_CHECK_DATA;

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(PGPVerify(edInputFile.getText()));
		}
	}
	
	private void SetResults(String Res)
	{
		if ((!isNullOrEmpty(Res))) {
			mmResult.setText(Res);
		} else {
			mmResult.setText("Finished. Unknown status.");
		}
	}
	
	private String PGPVerify(String InputFileName)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			if (((Msg.getMainPart() == null) || ((Msg.getMainPart().getMessagePartHandler() == null) || Msg.getMainPart().getIsActivatedMessagePartHandler()))) {
				Stream.Free();
				return "Mesage not encoded. No action done.";
			}

			if (Msg.getMainPart().getMessagePartHandler().getIsError()) {
				Result = Msg.getMainPart().getMessagePartHandler().getErrorText();
				Res = SBMIME.EL_ERROR;
			} else {
				try {
					TElMessagePartHandlerPGPMime Handler = (TElMessagePartHandlerPGPMime)Msg.getMainPart().getMessagePartHandler();
					Handler.setVerifyingKeys(Keyring);

					try {
						Res = Msg.getMainPart().getMessagePartHandler().decode(true);
					} catch (Exception E) {
						Result = E.getMessage();
						Res = SBMIME.EL_ERROR;
					}
				} catch (Exception ex) {
					Result = "Unknown message handler.";
					Res = SBMIME.EL_ERROR;
				}
			}
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}

			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
		} else {
			if (((Res == SBMIME.EL_WARNING) && ((((Msg.getMainPart().getMessagePartHandler()) != null)) && (!isNullOrEmpty(Msg.getMainPart().getMessagePartHandler().getErrorText()))))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			} else {
				Result = "Message verified OK";
			}

			if (((((Msg.getMainPart().getMessagePartHandler()) != null)) && (Msg.getMainPart().getMessagePartHandler() instanceof TElMessagePartHandlerPGPMime))) {
				Result = Result + "" + vbCrLf + vbCrLf + "Signature verified with:" + vbCrLf;

				TElMessagePartHandlerPGPMime Handler = (TElMessagePartHandlerPGPMime)Msg.getMainPart().getMessagePartHandler();
				Result = (Result + WriteKeyringInfo(Handler.getVerifyingKeys()));
			}
		}

		return Result;
	}
	
	private void PGPSignNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_KEYS;
				}

				break;
			case PAGE_SELECT_KEYS:
				if ((SecretRing.getSecretCount() == 0)) {
					showErrorMessage("No secret key selected. Please select one.", "Secure Mail");
				} else {
					NextPage = PAGE_CHECK_DATA;
				}

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(PGPSign(edInputFile.getText(), edOutputFile.getText()));
		}
	}
	
	private String PGPSign(String InputFileName, String OutputFileName)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePartHandlerPGPMime PGPMime = new TElMessagePartHandlerPGPMime(null);
		Msg.getMainPart().setMessagePartHandler(PGPMime);

		PGPMime.setSigningKeys(SecretRing);
		PGPMime.setOnKeyPassphrase(new TSBPGPKeyPassphraseEvent(OnKeyPass));
		PGPMime.setSign(true);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message signed and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if ((Res == SBMIME.EL_HANDLERR_ERROR)) {
				Result = "Message: \"" + PGPMime.getErrorText() + "\"";
			}
			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}
	
	TSBPGPKeyPassphraseEvent.Callback OnKeyPass = new TSBPGPKeyPassphraseEvent.Callback() {
		public void tsbpgpKeyPassphraseEventCallback(TObject sender,
				TElPGPCustomSecretKey key, TSBString pass, TSBBoolean cancel) {
			pass.value = requestPassphrase();
			cancel.value = (pass.value.length() == 0);
		}
	};
	private JTabbedPane PageControl; 
	private JLabel lbSelectFiles;
	private final ButtonGroup buttonGroup_3 = new ButtonGroup();
		
	private void PGPDecryptNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_KEYS;
				}

				break;
			case PAGE_SELECT_KEYS:
				if ((Keyring.getSecretCount() == 0)) {
					showErrorMessage("No recipient secret keys selected. Please select one.", "Secure Mail");
				} else {
					NextPage = PAGE_CHECK_DATA;
				}

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(PGPDecrypt(edInputFile.getText(), edOutputFile.getText()));
		}
	}
	
	private String PGPDecrypt(String InputFileName, String OutputFileName)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			if (((Msg.getMainPart() == null) || ((Msg.getMainPart().getMessagePartHandler() == null) || Msg.getMainPart().getIsActivatedMessagePartHandler()))) {
				Stream.Free();
				return "Mesage not encoded. No action done.";
			}

			if (Msg.getMainPart().getMessagePartHandler().getIsError()) {
				Result = Msg.getMainPart().getMessagePartHandler().getErrorText();
				Res = SBMIME.EL_ERROR;
			} else {
				try {
					TElMessagePartHandlerPGPMime Handler = (TElMessagePartHandlerPGPMime)Msg.getMainPart().getMessagePartHandler();

					Handler.setDecryptingKeys(Keyring);
					Handler.setOnKeyPassphrase(new TSBPGPKeyPassphraseEvent(OnKeyPass));
					try {
						Res = Handler.decode(true);
					} catch (Exception E) {
						Result = E.getMessage();
						Res = SBMIME.EL_ERROR;
					}
				} catch (Exception ex) {
					Result = "Unknown message handler.";
					Res = SBMIME.EL_ERROR;
				}
			}
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}

			Result = String.format("Error parsing mime message \"%s\"." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePart MainPart = Msg.getMainPart().getMessagePartHandler().getDecodedPart();
		Msg.getMainPart().getMessagePartHandler().setDecodedPart(null);
		Msg.setMainPart(MainPart, false);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message decrypted and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}

			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}	
	
	private String SMimeVerify(String InputFileName)
	{
		int Res = 0;
		String Result = "";
		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "rw", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			if (((Msg.getMainPart() == null) || ((Msg.getMainPart().getMessagePartHandler() == null) || Msg.getMainPart().getIsActivatedMessagePartHandler()))) {
				Stream.Free();
				return "Mesage not encoded. No action done.";
			}

			if (Msg.getMainPart().getMessagePartHandler().getIsError()) {
				Result = Msg.getMainPart().getMessagePartHandler().getErrorText();
				Res = SBMIME.EL_ERROR;
			} else if ((Msg.getMainPart().getMessagePartHandler() instanceof TElMessagePartHandlerSMime)) {
				TElMessagePartHandlerSMime Handler = (TElMessagePartHandlerSMime)Msg.getMainPart().getMessagePartHandler();
				Handler.setCertificatesStorage(MemoryCertStorage);
				try {
					Res = Msg.getMainPart().getMessagePartHandler().decode(true);
				} catch (Exception E) {
					Result = E.getMessage();
					Res = SBMIME.EL_ERROR;
				}

				if ((Handler.getErrors() != 0)) {
					if ((!isNullOrEmpty(Result))) {
						Result = Result + vbCrLf;
					}

					Result = Result + "Errors: ";
					if (((SBSMIMECore.smeUnknown & Handler.getErrors()) != 0)) {
						Result = (Result + "smeUnknown, ");
					}
					if (((SBSMIMECore.smeSignaturePartNotFound & Handler.getErrors()) != 0)) {
						Result = (Result + "smeSignaturePartNotFound, ");
					}
					if (((SBSMIMECore.smeBodyPartNotFound & Handler.getErrors()) != 0)) {
						Result = (Result + "smeBodyPartNotFound, ");
					}
					if (((SBSMIMECore.smeInvalidSignature & Handler.getErrors()) != 0)) {
						Result = (Result + "smeInvalidSignature, ");
					}
					if (((SBSMIMECore.smeSigningCertificateMismatch & Handler.getErrors()) != 0)) {
						Result = (Result + "smeSigningCertificateMismatch, ");
					}
					if (((SBSMIMECore.smeEncryptingCertificateMismatch & Handler.getErrors()) != 0)) {
						Result = (Result + "smeEncryptingCertificateMismatch, ");
					}
					if (((SBSMIMECore.smeNoData & Handler.getErrors()) != 0)) {
						Result = (Result + "smeNoData, ");
					}

					StringBuilder sb = new StringBuilder(Result);
					sb.delete((Result.length() - 3), 2);
					Result = sb.toString();
				}
			} else {
				Result = "Unknown message handler.";
				Res = SBMIME.EL_ERROR;
			}
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Error parsing mime message \"%s\"." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
		} else {
			Result = "Message verified OK";
			if (((((Msg.getMainPart().getMessagePartHandler()) != null)) && (Msg.getMainPart().getMessagePartHandler() instanceof TElMessagePartHandlerSMime))) {
				Result = Result + vbCrLf + vbCrLf + "Signed with:" + vbCrLf;

				TElMessagePartHandlerSMime Handler = (TElMessagePartHandlerSMime)Msg.getMainPart().getMessagePartHandler();
				Result = Result + WriteCertificateInfo(Handler.getDecoderSignCertStorage()	);
			}
		}

		return Result;
	}
	
	private void SMimeVerifyNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if ((isNullOrEmpty(edInputFile.getText()))) {
					showErrorMessage("You must select input file", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_CERTIFICATES;
				}

				break;
			case PAGE_SELECT_CERTIFICATES:
				NextPage = PAGE_CHECK_DATA;

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(SMimeVerify(edInputFile.getText()));
		}
	}
	
	private void SMimeSignNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_CERTIFICATES;
				}

				break;
			case PAGE_SELECT_CERTIFICATES:
				boolean Found = false;
				byte[] Buf = null;
				TSBInteger Sz = new TSBInteger();
				int i = 0;
				for (i = 0; i <= MemoryCertStorage.getCount() - 1; i++) {
					Sz.value = 0;
					MemoryCertStorage.getCertificate(i).saveKeyToBuffer(Buf, Sz);
					if ((Sz.value > 0)) {
						Found = true;
					}
				}

				if (!Found) {
					showErrorMessage("At least one certificate should be loaded with corresponding private key", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_ALGORITHM;
				}

				break;
			case PAGE_SELECT_ALGORITHM:
				NextPage = PAGE_CHECK_DATA;

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(SMimeSign(edInputFile.getText(), edOutputFile.getText(), GetSignAlgorithm()));
		}
	}
	
	private String SMimeSign(String InputFileName, String OutputFileName, String SignAlgorithm)
	{
		int Res = 0;
		String Result = "";
		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePartHandlerSMime SMime = new TElMessagePartHandlerSMime(null);
		SMime.setEncoderSignCertStorage(MemoryCertStorage);
		Msg.getMainPart().setMessagePartHandler(SMime);

		SMime.setEncoderSigned(true);
		SMime.setEncoderSignOnlyClearFormat(true);
		SMime.setEncoderMicalg(SignAlgorithm);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message signed and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
				if ((Result.indexOf(SBMessages.SB_MESSAGE_ERROR_NO_CERTIFICATE) > 0)) {
					Result = Result + " (at least one certificate should be loaded with corresponding sender (from email for message should be equal to certificate email field or to SubjectAlternativeName))";
				}
			} else if ((Res == SBMIME.EL_HANDLERR_ERROR)) {
				Result = "Message: \"" + SMime.getErrorText() + "\"";
			}

			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}
	
	private void PGPEncryptNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_KEYS;
				}

				break;
			case PAGE_SELECT_KEYS:
				if ((PublicRing.getPublicCount() == 0)) {
					showErrorMessage("No public key selected. Please select one.", "Secure Mail");
				} else {
					NextPage = PAGE_CHECK_DATA;
				}

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(PGPEncrypt(edInputFile.getText(), edOutputFile.getText()));
		}
	}
	
	private String PGPEncrypt(String InputFileName, String OutputFileName)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePartHandlerPGPMime PGPMime = new TElMessagePartHandlerPGPMime(null);
		Msg.getMainPart().setMessagePartHandler(PGPMime);

		PGPMime.setEncryptingKeys(PublicRing);
		PGPMime.setEncrypt(true);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message encrypted and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if ((Res == SBMIME.EL_HANDLERR_ERROR)) {
				Result = "Message: \"" + PGPMime.getErrorText() + "\"";
			}

			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}
	
	private void SMimeEncryptNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_CERTIFICATES;
				}

				break;
			case PAGE_SELECT_CERTIFICATES:
				if ((MemoryCertStorage.getCount() == 0)) {
					showErrorMessage("MessageDlg('No recipient certificate selected. Please select one.", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_ALGORITHM;
				}

				break;
			case PAGE_SELECT_ALGORITHM:
				NextPage = PAGE_CHECK_DATA;

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(SMimeEncrypt(edInputFile.getText(), edOutputFile.getText(), GetAlgorithm(), GetAlgorithmBitsInKey()));
		}
	}
	
	private String SMimeEncrypt(String InputFileName, String OutputFileName, int CryptAlgorithm, int CryptAlgorithmBitsInKey)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "r", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePartHandlerSMime SMime = new TElMessagePartHandlerSMime(null);
		SMime.setEncoderCryptCertStorage(MemoryCertStorage);
		Msg.getMainPart().setMessagePartHandler(SMime);

		SMime.setEncoderCrypted(true);
		SMime.setEncoderCryptBitsInKey(CryptAlgorithmBitsInKey);
		SMime.setEncoderCryptAlgorithm(CryptAlgorithm);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message encrypted and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}
			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}
	
	private void SMimeDecryptNext()
	{
		short NextPage = -1;
		switch ((CurrentPage)) {
			case PAGE_SELECT_ACTION:
				NextPage = PAGE_SELECT_FILES;

				break;
			case PAGE_SELECT_FILES:
				if (((isNullOrEmpty(edInputFile.getText())) || (isNullOrEmpty(edOutputFile.getText())))) {
					showErrorMessage("You must select both input and output files", "Secure Mail");
				} else {
					NextPage = PAGE_SELECT_CERTIFICATES;
				}

				break;
			case PAGE_SELECT_CERTIFICATES:
				if ((MemoryCertStorage.getCount() == 0)) {
					showErrorMessage("No recipient certificate selected. Please select one.", "Secure Mail");
				} else {
					NextPage = PAGE_CHECK_DATA;
				}

				break;
			case PAGE_CHECK_DATA:
				NextPage = PAGE_PROCESS;

				break;
			default:
				NextPage = PAGE_DEFAULT;
				break;
		}

		if (NextPage >= 0) {
			SetPage(NextPage);
		}

		if (NextPage == PAGE_PROCESS) {
			SetResults(SMimeDecrypt(edInputFile.getText(), edOutputFile.getText()));
		}
	}
	
	private String SMimeDecrypt(String InputFileName, String OutputFileName)
	{
		int Res = 0;
		String Result = "";

		TElMessage Msg = new TElMessage(cXMailerDemoFieldValue);
		TElFileStream Stream = new TElFileStream(InputFileName, "rw", true);
		try {
			short k = (SBMIME.mpoStoreStream | SBMIME.mpoLoadData | SBMIME.mpoCalcDataSize);
			Res = Msg.parseMessage(Stream, "", "", k, false, false, false);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			if (((Msg.getMainPart() == null) || ((Msg.getMainPart().getMessagePartHandler() == null) || Msg.getMainPart().getIsActivatedMessagePartHandler()))) {
				Stream.Free();
				return "Mesage not encoded. No action done.";
			}

			if (Msg.getMainPart().getMessagePartHandler().getIsError()) {
				Result = Msg.getMainPart().getMessagePartHandler().getErrorText();
				Res = SBMIME.EL_ERROR;
			} else if ((Msg.getMainPart().getMessagePartHandler() instanceof TElMessagePartHandlerSMime)) {
				TElMessagePartHandlerSMime SMime = (TElMessagePartHandlerSMime)Msg.getMainPart().getMessagePartHandler();
				SMime.setCertificatesStorage(MemoryCertStorage);
				try {
					Res = Msg.getMainPart().getMessagePartHandler().decode(true);
				} catch (Exception E) {
					Result = E.getMessage();
					Res = SBMIME.EL_ERROR;
				}
			} else {
				Result = "Unknown message handler.";
				Res = SBMIME.EL_ERROR;
			}
		}

		Stream.Free();

		if (((Res != SBMIME.EL_OK) && (Res != SBMIME.EL_WARNING))) {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}

			Result = String.format("Error parsing mime message %s." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%d", InputFileName, Res, Result);
			return Result;
		}

		TElMessagePart MainPart = Msg.getMainPart().getMessagePartHandler().getDecodedPart();
		Msg.getMainPart().getMessagePartHandler().setDecodedPart(null);
		Msg.setMainPart(MainPart, false);

		Stream = new TElFileStream(OutputFileName, "rw", true);
		try {
			Res = Msg.assembleMessage(Stream, "utf-8", TElHeaderEncoding.heBase64, "base64", "base64", true);
		} catch (Exception E) {
			Result = E.getMessage();
			Res = SBMIME.EL_ERROR;
		}

		if (((Res == SBMIME.EL_OK) || (Res == SBMIME.EL_WARNING))) {
			Result = "Message decrypted and assembled OK";
		} else {
			if ((!isNullOrEmpty(Result))) {
				Result = "Message: \"" + Result + "\"";
			} else if (((Res == SBMIME.EL_HANDLERR_ERROR) && (((Msg.getMainPart().getMessagePartHandler()) != null)))) {
				Result = "Message: \"" + Msg.getMainPart().getMessagePartHandler().getErrorText() + "\"";
			}

			Result = String.format("Failed to assemble a message." + vbCrLf + "ElMime error code: %d" + vbCrLf + "%s", Res, Result);
		}

		Stream.Free();
		return Result;
	}
	
	private int GetAlgorithm()
	{
		if (rbDES.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_DES;
		}
		if (rbTripleDES.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_3DES;
		}
		if (rbRC2.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_RC2;
		}
		if ((rbRC4_40.isSelected() || rbRC4_128.isSelected())) {
			return SBConstants.SB_ALGORITHM_CNT_RC4;
		}
		if (rbAES_128.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_AES128;
		}
		if (rbAES_192.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_AES192;
		}
		if (rbAES_256.isSelected()) {
			return SBConstants.SB_ALGORITHM_CNT_AES256;
		}
		return SBConstants.SB_ALGORITHM_CNT_3DES;
	}
	
	private int GetAlgorithmBitsInKey()
	{
		if (rbDES.isSelected()) {
			return 56;
		}
		if (rbTripleDES.isSelected()) {
			return 168;
		}
		if (rbRC2.isSelected()) {
			return 128;
		}
		if (rbRC4_40.isSelected()) {
			return 40;
		}
		if (rbRC4_128.isSelected()) {
			return 128;
		}
		if (rbAES_128.isSelected()) {
			return 128;
		}
		if (rbAES_192.isSelected()) {
			return 192;
		}
		if (rbAES_256.isSelected()) {
			return 256;
		}
		return 168;
	}
		
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
        SBMIME.initialize();
        SBSMIMECore.initialize();
        SBPGPMIME.initialize();	

        MemoryCertStorage = new TElMemoryCertStorage();
        Keyring = new TElPGPKeyring();
        SecretRing = new TElPGPKeyring();
        PublicRing = new TElPGPKeyring();
                
        SetPage(PAGE_DEFAULT);

		tsSelectAction.setVisible(true);
		memoryCertStorage = new TElMemoryCertStorage(null);
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".png");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}	
	
	public void SetPage(short Page)
	{
		switch ((Page)) {
			case PAGE_SELECT_ACTION:
				PageControl.setSelectedComponent(tsSelectAction);

				break;
			case PAGE_SELECT_FILES:
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
					case ACTION_PGPMIME_ENCRYPT:
						lbSelectFiles.setText("<html><body><center>Please select message file to encrypt and file where to write encrypted data</center></body></html>");
						break;
					case ACTION_SMIME_DECRYPT:
					case ACTION_PGPMIME_DECRYPT:
						lbSelectFiles.setText("<html><body><center>Please select input (encrypted) file and file where to write decrypted data</center></body></html>");
						break;
					case ACTION_SMIME_SIGN:
					case ACTION_PGPMIME_SIGN:
						lbSelectFiles.setText("<html><body><center>Please select file to sign and file where to write signed data</center></body></html>");
						break;
					case ACTION_SMIME_VERIFY:
					case ACTION_PGPMIME_VERIFY:
						lbSelectFiles.setText("<html><body><center>Please select file with a signed message</center></body></html>");
						break;
				}

				boolean b = ((Action != ACTION_SMIME_VERIFY) && (Action != ACTION_PGPMIME_VERIFY));
				edOutputFile.setVisible(b);
				lbOutputFile.setVisible(b);
				sbOutputFile.setVisible(b);
				PageControl.setSelectedComponent(tsSelectFiles);

				break;
			case PAGE_SELECT_CERTIFICATES:
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
						lbSelectCertificates.setText(htmlBracket("Please choose certificates which should be used to encrypt message"));

						break;
					case ACTION_SMIME_DECRYPT:
						lbSelectCertificates.setText(htmlBracket("Please select certificates which may be used to decrypt message. Each certificate should be loaded with corresponding private key"));

						break;
					case ACTION_SMIME_SIGN:
						lbSelectCertificates.setText(htmlBracket("Please choose certificates which should be used to sign the file. At least one certificate must be loaded with corresponding private key"));

						break;
					case ACTION_SMIME_VERIFY:
						lbSelectCertificates.setText(htmlBracket("Please select certificates which may be used to verify digital signature. Note, that in most cases signer's certificates are included in signed message, so you may leave certificate list empty"));
						break;
				}

				PageControl.setSelectedComponent(tsSelectCertificate);

				break;
			case PAGE_SELECT_ALGORITHM:
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
						PageControl.setSelectedComponent(tsAlgorithm);
						break;
					case ACTION_SMIME_SIGN:
						PageControl.setSelectedComponent(tsSignAlgorithm);
						break;
				}

				break;
			case PAGE_SELECT_KEYS:
				switch ((Action)) {
					case ACTION_PGPMIME_ENCRYPT:
						lbSelectKey.setText(htmlBracket("Please choose PGP public key which should be used to encrypt message"));
						lbKeyring.setText("Public keyring:");
						break;
					case ACTION_PGPMIME_DECRYPT:
						lbSelectKey.setText(htmlBracket("Please select PGP secret keys which may be used to decrypt message"));
						break;
					case ACTION_PGPMIME_SIGN:
						lbSelectKey.setText(htmlBracket("Please choose PGP secret key which should be used to sign the file"));
						lbKeyring.setText("Secret keyring:");
						break;
					case ACTION_PGPMIME_VERIFY:
						lbSelectKey.setText(htmlBracket("Please select PGP public keys which may be used to verify digital signature."));
						break;
				}

				if (((Action == ACTION_PGPMIME_ENCRYPT) || (Action == ACTION_PGPMIME_SIGN))) {
					PageControl.setSelectedComponent(tsSelectKey);
				} else {
					PageControl.setSelectedComponent(tsSelectKeys);
				}

				break;
			case PAGE_CHECK_DATA:
				StringBuilder sb = new StringBuilder(0);
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
					case ACTION_PGPMIME_ENCRYPT:
						lbInfo.setText("Ready to start encryption. Please check all the parameters to be valid");
						btnDoIt.setText("Encrypt");
						mmInfo.setText("");
						sb.setLength(0);
						sb.append(("File to encrypt: " + edInputFile.getText() + sLF + sLF));
						sb.append(("File to write encrypted data: " + edOutputFile.getText() + sLF + sLF));
						if ((Action == ACTION_SMIME_ENCRYPT)) {
							sb.append(("Certificates: " + sLF));
							sb.append(WriteCertificateInfo(MemoryCertStorage));
							sb.append(("Algorithm: " + GetAlgorithmName() + sLF));
						} else {
							sb.append(("Keys: " + sLF));
							sb.append(WriteKeyringInfo(PublicRing));
						}
						mmInfo.setText(sb.toString());

						break;
					case ACTION_SMIME_SIGN:
					case ACTION_PGPMIME_SIGN:
						lbInfo.setText(htmlBracket("Ready to start signing. Please check that all signing options are correct."));
						btnDoIt.setText("Sign");
						mmInfo.setText("");
						sb.setLength(0);
						sb.append(("File to sign: " + edInputFile.getText() + sLF + sLF));
						sb.append(("File to write signed data: " + edOutputFile.getText() + sLF + sLF));
						if ((Action == ACTION_SMIME_SIGN)) {
							sb.append(("Certificates: " + sLF));
							sb.append(WriteCertificateInfo(MemoryCertStorage));
							sb.append(("Algorithm: " + GetSignAlgorithm() + sLF));
						} else {
							sb.append(("Keys: " + sLF));
							sb.append(WriteKeyringInfo(SecretRing));
						}
						mmInfo.setText(sb.toString());

						break;
					case ACTION_SMIME_DECRYPT:
					case ACTION_PGPMIME_DECRYPT:
						lbInfo.setText(htmlBracket("Ready to start decryption. Please check that all decryption options are correct."));
						btnDoIt.setText("Decrypt");
						mmInfo.setText("");
						sb.setLength(0);
						sb.append(("File to decrypt: " + edInputFile.getText() + sLF + sLF));
						sb.append(("File to write decrypted data: " + edOutputFile.getText() + sLF + sLF));
						if ((Action == ACTION_SMIME_DECRYPT)) {
							sb.append(("Certificates: " + sLF));
							sb.append(WriteCertificateInfo(MemoryCertStorage));
						} else {
							sb.append(("Keys: " + sLF));
							sb.append(WriteKeyringInfo(Keyring));
						}
						mmInfo.setText(sb.toString());

						break;
					case ACTION_SMIME_VERIFY:
					case ACTION_PGPMIME_VERIFY:
						lbInfo.setText(htmlBracket("Ready to start verifying. Please check that all options are correct."));
						btnDoIt.setText("Verify");
						mmInfo.setText("");
						sb.setLength(0);
						sb.append(("File to verify: " + edInputFile.getText() + sLF + sLF));
						if ((Action == ACTION_SMIME_VERIFY)) {
							sb.append(("Certificates: " + sLF));
							sb.append(WriteCertificateInfo(MemoryCertStorage));
						} else {
							sb.append(("Keys: " + sLF));
							sb.append(WriteKeyringInfo(Keyring));
						}
						mmInfo.setText(sb.toString());
						break;
				}

				PageControl.setSelectedComponent(tsCheckData);

				break;
			case PAGE_PROCESS:
				switch ((Action)) {
					case ACTION_SMIME_ENCRYPT:
					case ACTION_PGPMIME_ENCRYPT:
						lbResult.setText("Encryption results:");
						break;
					case ACTION_SMIME_SIGN:
					case ACTION_PGPMIME_SIGN:
						lbResult.setText("Signing results:");
						break;
					case ACTION_SMIME_DECRYPT:
					case ACTION_PGPMIME_DECRYPT:
						lbResult.setText("Decryption results:");
						break;
					case ACTION_SMIME_VERIFY:
					case ACTION_PGPMIME_VERIFY:
						lbResult.setText("Verifying results:");
						break;
					default:
						lbResult.setText("Results:");
						break;
				}

				mmResult.setText("Processing...");
				PageControl.setSelectedComponent(tsResult);

				break;
			default:
				PageControl.setSelectedComponent(tsSelectAction);
				Page = PAGE_SELECT_ACTION;
				break;
		}

		btnBack.setEnabled(((Page != PAGE_SELECT_ACTION) && (Page != PAGE_PROCESS)));
		btnNext.setEnabled(Page != PAGE_CHECK_DATA);
		if ((Page == PAGE_PROCESS)) {
			btnNext.setText("New Task");
			btnCancel.setText("Finish");
		} else {
			btnNext.setText("Next >");
			btnCancel.setText("Cancel");
		}

		CurrentPage = Page;
	}

	private String htmlBracket(String s) {
		return "<html><body><center>" + s + "</center></body></html>";
	}

	private String GetSignAlgorithm()
	{
		if (rbMD5.isSelected()) {
			return "MD5";
		}
		return "SHA1";
	}
	
	private String GetAlgorithmName()
	{
		if (rbDES.isSelected()) {
			return rbDES.getText();
		}
		if (rbTripleDES.isSelected()) {
			return rbTripleDES.getText();
		}
		if (rbRC2.isSelected()) {
			return rbRC2.getText();
		}
		if (rbRC4_40.isSelected()) {
			return rbRC4_40.getText();
		}
		if (rbRC4_128.isSelected()) {
			return rbRC4_128.getText();
		}
		if (rbAES_128.isSelected()) {
			return rbAES_128.getText();
		}
		if (rbAES_192.isSelected()) {
			return rbAES_192.getText();
		}
		if (rbAES_256.isSelected()) {
			return rbAES_256.getText();
		}
		return rbTripleDES.getText();
	}

	
	private String WriteCertificateInfo(TElCustomCertStorage Storage)
	{
		TElX509Certificate Cert = new TElX509Certificate();
		int j = 0;
		int i = 0;
		byte[] Buf = null;
		TSBInteger Sz = new TSBInteger();
		String Result = "";
		for (i = 0; i <= Storage.getCount() - 1; i++) {
			Cert = Storage.getCertificate(i);
			Result = Result + "Certificate #" + (i + 1) + ":" + sLF;
			Result = Result + "Issuer:" + sLF;
			for (j = 0; j <= Cert.getIssuerRDN().getCount() - 1; j++) {
				Result = Result + GetStringByOID(Cert.getIssuerRDN().getOID(j)) + "=" + SBStrUtils.utf8ToStr(Cert.getIssuerRDN().getValue(j)) + sLF;
			}
			Result = (Result + ("Subject:" + sLF));
			for (j = 0; j <= Cert.getSubjectRDN().getCount() - 1; j++) {
				Result = Result + GetStringByOID(Cert.getSubjectRDN().getOID(j)) + "=" + SBStrUtils.utf8ToStr(Cert.getSubjectRDN().getValue(j)) + sLF;
			}

			Sz.value = 0;
			Buf = null;
			Cert.saveKeyToBuffer(Buf, Sz);
			if ((Sz.value > 0)) {
				Result = (Result + "Private key available");
			} else {
				Result = (Result + "Private key is not available");
			}

			Result = Result + sLF + sLF;
		}
		return Result;
	}
	
	private String WriteKeyringInfo(TElPGPKeyring Keyring)
	{
		int j = 0;
		int i = 0;
		String Result = "";
		Result = "Secret Keys:" + sLF;
		for (i = 0; i <= Keyring.getSecretCount() - 1; i++) {
			Result = Result + "Key #" + (i + 1) + ":" + sLF;
			Result = Result + " Names: " + GetPublicKeyNames(Keyring.getSecretKeys(i).getPublicKey()) + sLF;
			Result = Result + " KeyID: " + SBPGPUtils.keyID2Str(Keyring.getSecretKeys(i).keyID(), true) + sLF;
			Result = Result + " KeyFP: " + SBPGPUtils.keyFP2Str(Keyring.getSecretKeys(i).keyFP()) + sLF;
			if (Keyring.getSecretKeys(i).getSubkeyCount() > 0) {
				for (j = 0; j <= Keyring.getSecretKeys(i).getSubkeyCount() - 1; j++) {
					Result = Result + " KeyID: " + SBPGPUtils.keyID2Str(Keyring.getSecretKeys(i).getSubkey(j).keyID(), true) + sLF;
					Result = Result + " KeyFP: " + SBPGPUtils.keyFP2Str(Keyring.getSecretKeys(i).getSubkey(j).keyFP()) + sLF;
				}
			}
		}
		Result = Result + sLF + "Public Keys:" + sLF;

		for (i = 0; i <= Keyring.getPublicCount() - 1; i++) {
			Result = Result + "Key #" + (i + 1) + ":" + sLF;
			Result = Result + " Names: " + GetPublicKeyNames(Keyring.getPublicKeys(i)) + sLF;
			Result = Result + " KeyID: " + SBPGPUtils.keyID2Str(Keyring.getPublicKeys(i).keyID(), true) + sLF;
			Result = Result + " KeyFP: " + SBPGPUtils.keyFP2Str(Keyring.getPublicKeys(i).keyFP()) + sLF;
			if ((Keyring.getPublicKeys(i).getSubkeyCount() > 0)) {
				for (j = 0; j <= Keyring.getPublicKeys(i).getSubkeyCount() - 1; j++) {
					Result = Result + " KeyID: " + SBPGPUtils.keyID2Str(Keyring.getPublicKeys(i).getSubkey(j).keyID(), true) + sLF;
					Result = Result + " KeyFP: " + SBPGPUtils.keyFP2Str(Keyring.getPublicKeys(i).getSubkey(j).keyFP()) + sLF;
				}
			}
		}
		return Result;
	}
	
	public String GetStringByOID(byte[] S)
	{
		if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_COMMON_NAME.Data))) {
			return "CommonName";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_COUNTRY.Data))) {
			return "Country";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_LOCALITY.Data))) {
			return "Locality";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_STATE_OR_PROVINCE.Data))) {
			return "StateOrProvince";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_ORGANIZATION.Data))) {
			return "Organization";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_ORGANIZATION_UNIT.Data))) {
			return "OrganizationUnit";
		} else if ((SBUtils.compareContent(S, SBConstants.SB_CERT_OID_EMAIL.Data))) {
			return "Email";
		} else {
			return "UnknownField";
		}
	}
	
	private String GetPublicKeyNames(TElPGPPublicKey Key)
	{
		if ((Key == null)) {
			return "";
		}

		int i = 0;
		String Result = "";
		for (i = 0; i <= Key.getUserIDCount() - 1; i++) {
			if ((!isNullOrEmpty(Key.getUserID(i).getName()))) {
				if ((!isNullOrEmpty(Result))) {
					Result = (Result + ", ");
				}
				Result = Result + Key.getUserID(i).getName();
			}
		}
		return Result;
	}
	
	private boolean isNullOrEmpty(String n) {
		if (n == null) return true;
		if (n.length() == 0) return true;
		return false;
	}
}
