import java.util.Vector;

import javax.swing.table.AbstractTableModel;


public class BinTableModel extends AbstractTableModel{
	private static final long serialVersionUID = 1L;

	public static final int O_INDEX = 0;
	public static final int T_INDEX = 1;
	
	protected Vector<BinDataRow> dataVector = new Vector<BinDataRow>();
	
    protected String[] columnNames = {
    		"Offset", 
    		"Text", 
    };
    
    public void addItem(String offset, String txt){
    	dataVector.addElement(new BinDataRow(offset, txt));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        BinDataRow record = (BinDataRow)dataVector.get(row);
        switch (col) {
        	case O_INDEX:
        		return record.Offset;
        	case T_INDEX:
	        	 return record.Text;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}
}
