import java.util.Enumeration;
import java.util.Hashtable;

import SecureBlackbox.MIME.TElMessagePart;
import javax.swing.tree.DefaultMutableTreeNode;

public class TreeNodeInfo extends DefaultMutableTreeNode
{
	private static final long serialVersionUID = 1L;
	boolean fLocked = false;
    protected TagInfo fTagInfo = TagInfo.tiNull;
    protected Object fTagObj = null;
    protected MimeViewer_PlugControl fPlugFrame = null;
    protected int fLevel = 0;
	String cap = "";
	
    public TreeNodeInfo(TagInfo tagInfo, Object tagObject)
    {
        LinkTagObj(tagInfo, tagObject);
    }

    public int getLevel()
    {
    	return fLevel;
    }
    
    public void setLevel(int value) {
        fLevel = value;
    }

    public TagInfo getTagInfo()
    {
        return fTagInfo;
    }

    public Object getTagObj()
    {
        return fTagObj;
    }

    public boolean getLocked()
    {
        return fLocked;
    }

    public static TElMessagePart GetMessagePartFromTagObject( Object tagObject )
    {
    	if (tagObject instanceof TElMessagePart)
    		return (TElMessagePart)tagObject;

    	TElMessagePart mp = null;
    	
    	if (tagObject instanceof ElMessageDemo)
    	{
	    	ElMessageDemo md = (ElMessageDemo)tagObject;
	        if ( md != null )
	            mp = md.getMainPart();
    	}
    	
        return mp;
    }

    protected void InitPlugFrame()
    {
        fPlugFrame = null;
        if ( (fTagInfo == TagInfo.tiNull) & (fTagObj == null) )
            return;

        TElMessagePart messagePart = GetMessagePartFromTagObject(fTagObj);

        if ( (messagePart != null) || ( MimeViewer_PlugControl.hashPlugControls.size() > 0 ) )
        {
            Hashtable<?, ?> v = MimeViewer_PlugControl.hashPlugControls;
            for (Enumeration<?> e = v.elements() ; e.hasMoreElements() ;) {
                MimeViewer_PlugControl ctrl = (MimeViewer_PlugControl) e.nextElement();

                if ( ctrl != null )
                {
                 if ( ctrl.IsSupportedMessagePart(messagePart, fTagInfo, this) )
                 {
                  fPlugFrame = ctrl;
                  // init plugin icons
                  // todo: ???
                  return;
                 }
                }
            }            
        }
    }

    public void LinkTagObj(TagInfo tagInfo, Object tagObject)
    {
        fTagInfo = TagInfo.tiNull;
        if ( fTagInfo != tagInfo )
        {
            fTagInfo = tagInfo;
            // set icons
            // todo: ???
        }
        fTagObj = tagObject;
        InitPlugFrame();
    }

	public void setText(String msg) {
		cap = msg;
	}
	
	public String toString() {
		return cap;
	} 
	
    public void UpdatePlugFrame()
    {
        if ( (fPlugFrame == null) || (fTagInfo == TagInfo.tiNull) || (fTagObj == null) )
            return;
        TElMessagePart messagePart = GetMessagePartFromTagObject(fTagObj);

        fPlugFrame.InitSafe(messagePart, fTagInfo, this, true);
    }

    public MimeViewer_PlugControl getPlugFrame()
    {
    	return fPlugFrame;
    }
    
    public void setPlugFrame(MimeViewer_PlugControl value) {
    	fPlugFrame = value;
    }

	public String getText() {
		return cap;
	}
}
