import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.border.TitledBorder;
import javax.swing.JPasswordField;
import javax.swing.SwingConstants;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;


public class ConnectDialog extends JDialog {

	private static final long serialVersionUID = 6970940619980960191L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbServer;
	private JTextField tbPort;
	private JTextField tbUsername;
	private JPasswordField tbPassword;
	private JLabel lblSsltlsMode;
	private JComboBox<String> cmbMode;
	private JCheckBox cbUseSSL;
	private boolean isOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ConnectDialog dialog = new ConnectDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ConnectDialog() {
		setTitle("Login");
		setBounds(100, 100, 325, 350);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblServer = new JLabel("Server");
		lblServer.setBounds(10, 11, 69, 14);
		contentPanel.add(lblServer);
		
		tbServer = new JTextField();
		tbServer.setBounds(10, 29, 201, 20);
		contentPanel.add(tbServer);
		tbServer.setText("imap.gmail.com");
		tbServer.setColumns(10);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(222, 11, 46, 14);
		contentPanel.add(lblPort);
		
		tbPort = new JTextField();
		tbPort.setHorizontalAlignment(SwingConstants.RIGHT);
		tbPort.setText("993");
		tbPort.setBounds(221, 29, 86, 20);
		contentPanel.add(tbPort);
		tbPort.setColumns(10);
		
		cbUseSSL = new JCheckBox("Use SSL");
		cbUseSSL.setSelected(true);
		cbUseSSL.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				lblSsltlsMode.setEnabled(cbUseSSL.isSelected());
				cmbMode.setEnabled(cbUseSSL.isSelected());
				if (cbUseSSL.isSelected() && (cmbMode.getSelectedIndex() == 1))
					tbPort.setText("993");
				else
					tbPort.setText("143");
			}
		});
		cbUseSSL.setBounds(6, 56, 97, 23);
		contentPanel.add(cbUseSSL);
		
		lblSsltlsMode = new JLabel("SSL/TLS Mode");
		lblSsltlsMode.setBounds(10, 86, 107, 14);
		contentPanel.add(lblSsltlsMode);
		
		cmbMode = new JComboBox<String>();
		cmbMode.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (cbUseSSL.isSelected() && (cmbMode.getSelectedIndex() == 1))
					tbPort.setText("993");
				else
					tbPort.setText("143");
			}
		});
		cmbMode.setModel(new DefaultComboBoxModel<String>(new String[] {"Explicit", "Implicit"}));
		cmbMode.setBounds(127, 82, 180, 22);
		cmbMode.setSelectedIndex(1);
		contentPanel.add(cmbMode);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Login credentials", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 121, 297, 139);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(10, 29, 108, 14);
		panel.add(lblUsername);
		
		tbUsername = new JTextField();
		tbUsername.setBounds(10, 47, 277, 20);
		panel.add(tbUsername);
		tbUsername.setColumns(10);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 78, 89, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(10, 96, 277, 20);
		panel.add(tbPassword);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public String getUsername() {
		return tbUsername.getText();
	}

	public String getPassword() {
		return new String(tbPassword.getPassword());
	}

	public int getSSLMode() {
		return cmbMode.getSelectedIndex();
	}

	public boolean isOK() {
		return isOk;
	}

	public String getServer() {
		return tbServer.getText();
	}

	public int getPort() {
		return Integer.parseInt(tbPort.getText());
	}

	public boolean getUseSSL() {
		return cbUseSSL.isSelected();
	}
}
