import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import SecureBlackbox.Mail.TSBPOP3MessageID;


public class ConTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int F_INDEX = 0;
	public static final int H_INDEX = 1;
	public static final int S_INDEX = 2;
	
	protected Vector<ConDataRow> dataVector = new Vector<ConDataRow>();
	
    protected String[] columnNames = {
    		"From",
    		"Header", 
    		"Size" 
    };
    
    public void addRow(String s, String i, String a, TSBPOP3MessageID tag){
    	dataVector.addElement(new ConDataRow(s, i, a, tag));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        ConDataRow record = (ConDataRow)dataVector.get(row);
        switch (col) {
        	case F_INDEX:
        		return record.From;
        	case H_INDEX:
	        	 return record.Header;
            case S_INDEX:
               return record.Size;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
		fireTableDataChanged();
	}

	public TSBPOP3MessageID getTag(int selectedRow) {
		return dataVector.get(selectedRow).Tag;
	}
}