import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import SecureBlackbox.PGP.*;

public class PanelSelectFiles extends JPanel {

	static final long serialVersionUID = 2316444152935088773L;
	JPanel contentPanel;
	JPanel titlePanel;
    
	public static JTextField txtPub;
	public static JTextField txtSec;
	
	public static TElPGPKeyring getKeys () {
		TElPGPKeyring keyring = new TElPGPKeyring();
		keyring.load(txtPub.getText(), txtSec.getText(), true);
		return keyring;
	}

	public PanelSelectFiles() {
		super();
		
		contentPanel = getContentPanel();
		contentPanel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));

		setLayout(new BorderLayout());

		JPanel secondaryPanel = new JPanel();
		secondaryPanel.setLayout(null);
		secondaryPanel.add(contentPanel);
		add(secondaryPanel, BorderLayout.CENTER);
		
        JLabel textLabel = new JLabel("<html>Step 1/6<br>Select keyring files</html>");
        textLabel.setBackground(Color.gray);
        textLabel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        textLabel.setOpaque(true);
        
        titlePanel = new JPanel();
        titlePanel.setLayout(new BorderLayout());
        titlePanel.setBackground(Color.gray);
        titlePanel.add(textLabel, BorderLayout.CENTER);
        add(titlePanel, BorderLayout.NORTH);
	}

	private JPanel getContentPanel() {
		txtPub = new JTextField();
		txtPub.setBounds(23, 71, 310, 20);
		txtSec = new JTextField();
		txtSec.setBounds(23, 115, 310, 20);
		
		JButton btnPubKey = new JButton("Browse...");
		btnPubKey.setBounds(343, 70, 97, 23);
		btnPubKey.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtPub.setText(getKeyFileName());
			}
		});

		JButton btnSecKey = new JButton("Browse...");
		btnSecKey.setBounds(343, 115, 97, 23);
		btnSecKey.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				txtSec.setText(getKeyFileName());
			}
		});

		JPanel result = new JPanel();
		result.setBounds(0, 0, 450, 252);
		result.setBorder(new EmptyBorder(5, 5, 5, 5));
		result.setLayout(null);

		JLabel label = new JLabel(" ");
		label.setBounds(15, 15, 3, 64);
		label.setBorder(new EmptyBorder(50, 0, 0, 0));
					
		result.add(label); 
		JLabel label_1 = new JLabel("Public keyring file");
		label_1.setBounds(23, 54, 148, 14);
		result.add(label_1);
		result.add(txtPub);
		result.add(btnPubKey);
		 
		JLabel label_2 = new JLabel("Secret keyring file");
		label_2.setBounds(23, 98, 148, 14);
		result.add(label_2);
		result.add(txtSec);
		result.add(btnSecKey);

		return result;
	}
	
	String getKeyFileName(){
		JFileChooser fc = new JFileChooser();

		FileFilter filter = new FileNameExtensionFilter("OpenPGP keyring files", "pkr", "skr", "pgp", "gpg", "asc");
	    fc.setFileFilter(filter);		
	
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public boolean isFieldsValidated() {
		return (txtPub.getText().length() != 0) && (txtSec.getText().length() != 0);
	}

	public void addFieldsListener(final ActionListener l) {
		Common.addTextDocumentLisner(txtPub, l);
		Common.addTextDocumentLisner(txtSec, l);
	}

	public String getSecKeyringPath() {
		return txtSec.getText();
	}

	public String getPubKeyringPath() {
		return txtPub.getText();
	}
}
