import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import SecureBlackbox.PDF.TElPDFSignature;


public class SignTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int TYPE_INDEX = 0;
	public static final int NAME_INDEX = 1;
	public static final int AUTH_INDEX = 2;
	public static final int STIM_INDEX = 3;
	public static final int TIMS_INDEX = 4;
	public static final int VLDT_INDEX = 5;
	
	protected Vector<SignDataRow> dataVector = new Vector<SignDataRow>();
	
    protected String[] columnNames = {
    		"Type", 
    		"Name",
    		"Author",
    		"Signing time",
    		"Timestamped",
    		"Validity"
    };
    
    public void addRow(SignDataRow row) {
    	dataVector.addElement(row);
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        SignDataRow record = (SignDataRow)dataVector.get(row);
        switch (col) {
        	case TYPE_INDEX:
        		return record.Type;
        	case NAME_INDEX:
	        	 return record.Name;
        	case AUTH_INDEX:
        		return record.Author;
        	case STIM_INDEX:
        		return record.SignTime;
        	case TIMS_INDEX:
        		return record.Timestamped;
        	case VLDT_INDEX:
        		return record.Validity;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
		fireTableDataChanged();
	}

	public TElPDFSignature getTag(int selIndex) {
		return dataVector.get(selIndex).Tag;
	}

	public void change(SignDataRow row, int selIndex) {
		dataVector.set(selIndex, row);
	}
}