

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import SecureBlackbox.Base.*;

import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JPasswordField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;


public class Main extends JDialog implements ActionListener {
	private static final long serialVersionUID = -8938687539889635131L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbInputFile;
	private JTextField tbOutputFile;
	private JTextField tbKeyFile;
	private JPasswordField tbPassphrase;
	JComboBox<String> comboKeyContainerType;
	JComboBox<String> comboInputEncoding;
	JComboBox<String> comboOutputEncoding;
	JButton btnDecrypt;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			showErrorMessage(e.getMessage());
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		setTitle("ElPublicKeyCrypto decryption demo");
		setBounds(100, 100, 499, 333);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Settings", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 471, 257);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("Input filename");
		lblNewLabel.setBounds(20, 20, 163, 14);
		panel.add(lblNewLabel);
		{
			tbInputFile = new JTextField();
			tbInputFile.setBounds(20, 35, 362, 20);
			panel.add(tbInputFile);
			tbInputFile.setColumns(10);
		}
		{
			JButton btnBrowseInputFile = new JButton("Browse");
			btnBrowseInputFile.setBounds(385, 34, 80, 23);
			btnBrowseInputFile.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					tbInputFile.setText(getInputFileName());
				}
			});
			panel.add(btnBrowseInputFile);
		}
		{
			JLabel lblNewLabel_1 = new JLabel("Output filename");
			lblNewLabel_1.setBounds(20, 60, 163, 14);
			panel.add(lblNewLabel_1);
		}
		{
			tbOutputFile = new JTextField();
			tbOutputFile.setBounds(20, 77, 362, 20);
			panel.add(tbOutputFile);
			tbOutputFile.setColumns(10);
		}
		{
			JButton btnBrowseOutputFile = new JButton("Browse");
			btnBrowseOutputFile.setBounds(385, 76, 80, 23);
			btnBrowseOutputFile.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					tbOutputFile.setText(getOutputFileName());
				}
			});
			panel.add(btnBrowseOutputFile);
		}
		
		JLabel lblEncryptionAlgorithm = new JLabel("Encryption algorithm");
		lblEncryptionAlgorithm.setBounds(20, 108, 125, 14);
		panel.add(lblEncryptionAlgorithm);
		
		JLabel lblInputEncoding = new JLabel("Input encoding");
		lblInputEncoding.setBounds(155, 108, 100, 14);
		panel.add(lblInputEncoding);
		
		JLabel lblOutputEncoding = new JLabel("Output encoding");
		lblOutputEncoding.setBounds(265, 108, 117, 14);
		panel.add(lblOutputEncoding);
		
		JComboBox<String> comboAlgorithm = new JComboBox<String>();
		comboAlgorithm.setBounds(20, 124, 98, 22);
		comboAlgorithm.setModel(new DefaultComboBoxModel<String>(new String[] {"RSA"}));
		panel.add(comboAlgorithm);
		
		comboInputEncoding = new JComboBox<String>();
		comboInputEncoding.setBounds(155, 124, 69, 22);
		comboInputEncoding.setModel(new DefaultComboBoxModel<String>(new String[] {"Binary", "Base64"}));
		panel.add(comboInputEncoding);
		
		comboOutputEncoding = new JComboBox<String>();
		comboOutputEncoding.setBounds(265, 124, 80, 22);
		comboOutputEncoding.setModel(new DefaultComboBoxModel<String>(new String[] {"Binary", "Base64"}));
		panel.add(comboOutputEncoding);
		
		JLabel lblPublicKeyContainer = new JLabel("Private key container file");
		lblPublicKeyContainer.setBounds(20, 155, 163, 14);
		panel.add(lblPublicKeyContainer);
		
		tbKeyFile = new JTextField();
		tbKeyFile.setBounds(20, 170, 362, 20);
		panel.add(tbKeyFile);
		tbKeyFile.setColumns(10);
		
		JButton btnBrowseKeyFile = new JButton("Browse");
		btnBrowseKeyFile.setBounds(385, 169, 80, 23);
		btnBrowseKeyFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbKeyFile.setText(getKeyFileName());
			}
		});
		panel.add(btnBrowseKeyFile);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(20, 201, 98, 14);
		panel.add(lblPassword);
		
		JLabel label = new JLabel("Key container type");
		label.setBounds(188, 201, 131, 14);
		panel.add(label);
		
		tbPassphrase = new JPasswordField();
		tbPassphrase.setBounds(20, 218, 137, 20);
		panel.add(tbPassphrase);
		
		comboKeyContainerType = new JComboBox<String>();
		comboKeyContainerType.setBounds(188, 218, 131, 22);
		comboKeyContainerType.setModel(new DefaultComboBoxModel<String>(new String[] {"Generic public key", "X.509 certificate"}));
		panel.add(comboKeyContainerType);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnDecrypt = new JButton("Decrypt");
				btnDecrypt.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						boolean exists = (new File(tbInputFile.getText())).exists();
						if (!exists)
							showErrorMessage("Source file not found");
						else if (tbOutputFile.getText().length() == 0)
							showErrorMessage("Destination file not specified");
						else if (!new File(tbKeyFile.getText()).exists())
							showErrorMessage("Please specify public key file to use");
						else
							doDecrypt();						
					}
				});
				btnDecrypt.setEnabled(false);
				btnDecrypt.setActionCommand("OK");
				buttonPane.add(btnDecrypt);
				getRootPane().setDefaultButton(btnDecrypt);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		addFieldsListener(this);
	}
	
	public void addFieldsListener(final ActionListener l) {
		addTextDocumentLisner(tbInputFile, l);
		addTextDocumentLisner(tbOutputFile, l);
		addTextDocumentLisner(tbKeyFile, l);
	}
	
	public void addTextDocumentLisner(final JTextField txt, final ActionListener l) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				l.actionPerformed(new ActionEvent(txt, 0, "changed"));
			}

			public void insertUpdate(DocumentEvent arg0) {
				l.actionPerformed(new ActionEvent(txt, 1, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				l.actionPerformed(new ActionEvent(txt, 2, "remove"));
			}
		});
	} 
	
	protected String getKeyFileName() {
		return getFileName();
	}

	protected String getOutputFileName() {
		return getFileName();
	}

	protected String getInputFileName() {

		return getFileName();
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 
	
	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}
	
	protected void doDecrypt() {
		TElRSAPublicKeyCrypto Crypto;
		FileInputStream streamInput;
		FileOutputStream streamOutput;
		FileInputStream streamKey;
		boolean keyLoaded = false;
		TElRSAKeyMaterial KeyMaterial;
		TElX509Certificate cert;
		int certType;
		String errorMsg = "";
		int r;

		Crypto = new TElRSAPublicKeyCrypto();
		KeyMaterial = new TElRSAKeyMaterial();
		try 
		{
			if (comboKeyContainerType.getSelectedIndex() == 1)
			{
				cert = new TElX509Certificate();
				streamKey = new FileInputStream(tbKeyFile.getText());
				try
				{
					certType = TElX509Certificate.detectCertFileFormat(tbKeyFile.getText());
					if (certType == 1) // cfDER
					{
						try 
						{
							cert.loadFromStream(streamKey, 0);
							keyLoaded = true;
						} 
						catch(Exception e) 
						{
							errorMsg = e.getMessage();
						}
					}
					else if (certType == 2) // cfPEM
					{
						r = cert.loadFromStreamPEM(streamKey, new String (tbPassphrase.getPassword()), 0);
						if (r != 0) 
						{
							errorMsg = "PEM read error: " + r;
						} 
						else 
						{
							keyLoaded = true;
						}
					}
					else if (certType == 3) // cfPFX
					{
						r = cert.loadFromStreamPFX(streamKey,  new String (tbPassphrase.getPassword()), 0);
						if (r != 0) 
						{
							errorMsg = "PFX read error: " + r;
						} 
						else 
						{
							keyLoaded = true;
						}
					} 
					else 
					{
						errorMsg = "Unknown certificate format";
					}
					if (!keyLoaded)
					{
						throw (new Exception(errorMsg));
					}
				} 
				finally
				{ 
					streamKey.close();
				}
				KeyMaterial.assign(cert.getKeyMaterial());
			}
			else
			{
				streamKey = new FileInputStream(tbKeyFile.getText());
				try
				{
					KeyMaterial.setPassphrase(new String(tbPassphrase.getPassword()));
					KeyMaterial.loadSecret(streamKey, 0);
				}
				finally
				{
					streamKey.close();
				}
			}
			Crypto.setKeyMaterial(KeyMaterial);
			if (comboInputEncoding.getSelectedIndex() == 0)
			{
				Crypto.setInputEncoding(TSBPublicKeyCryptoEncoding.pkeBinary);
			}
			else
			{
				Crypto.setInputEncoding(TSBPublicKeyCryptoEncoding.pkeBase64);
			}
			if (comboOutputEncoding.getSelectedIndex() == 0)
			{
				Crypto.setOutputEncoding(TSBPublicKeyCryptoEncoding.pkeBinary);
			}
			else
			{
				Crypto.setOutputEncoding(TSBPublicKeyCryptoEncoding.pkeBase64);
			}
			streamInput = new FileInputStream(tbInputFile.getText());
			try
			{
				streamOutput = new FileOutputStream(tbOutputFile.getText());
				try
				{
					Crypto.decrypt(streamInput, streamOutput, 0);
				}
				finally
				{
					streamOutput.close();
				}
			}
			finally
			{
				streamInput.close();
			}
			showMessage("Success", "The file was decrypted successfully");
		} 
		catch(Exception e) 
		{
			showErrorMessage(e.getMessage());
		}
	}

	public void actionPerformed(ActionEvent e) {
		btnDecrypt.setEnabled(tbInputFile.getText().length() > 0 &&
				tbOutputFile.getText().length() > 0 && tbKeyFile.getText().length() > 0);
	}
}