import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ConnDialog extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbHost;
	private JPasswordField tbPassword;
	private JTextField tbUsername;
	private JTextField tbPrivateKeyFile;
	private JPasswordField tbKeyPassword;
	private JButton btnBrowse;
	private JButton okButton;
	private JButton cancelButton;
	private boolean isOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ConnDialog dialog = new ConnDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ConnDialog() {
		setTitle("Connection properties");
		setBounds(100, 100, 413, 328);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 385, 250);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblHost = new JLabel("Host");
		lblHost.setBounds(10, 23, 46, 14);
		panel.add(lblHost);
		
		tbHost = new JTextField();
		tbHost.setBounds(10, 42, 365, 20);
		panel.add(tbHost);
		tbHost.setColumns(10);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(10, 73, 123, 14);
		panel.add(lblUsername);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(204, 73, 171, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(204, 97, 171, 20);
		panel.add(tbPassword);
		
		tbUsername = new JTextField();
		tbUsername.setBounds(10, 97, 171, 20);
		panel.add(tbUsername);
		tbUsername.setColumns(10);
		
		JLabel lblPrivateKeyFile = new JLabel("Private key file for PUBLICKEY authentication type");
		lblPrivateKeyFile.setBounds(10, 128, 284, 14);
		panel.add(lblPrivateKeyFile);
		
		tbPrivateKeyFile = new JTextField();
		tbPrivateKeyFile.setBounds(10, 153, 319, 20);
		panel.add(tbPrivateKeyFile);
		tbPrivateKeyFile.setColumns(10);
		
		btnBrowse = new JButton("...");
		btnBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbPrivateKeyFile.setText(getOpenFileName());
			}
		});
		btnBrowse.setBounds(341, 152, 34, 23);
		panel.add(btnBrowse);
		
		tbKeyPassword = new JPasswordField();
		tbKeyPassword.setBounds(10, 209, 229, 20);
		panel.add(tbKeyPassword);
		
		JLabel lblPrivateKeyPassword = new JLabel("Private key password");
		lblPrivateKeyPassword.setBounds(10, 184, 199, 14);
		panel.add(lblPrivateKeyPassword);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	} 

	public boolean isOK() {
		return isOk;
	}

	public String getUsername() {
		return tbUsername.getText();
	}

	public String getPassword() {
		return new String(tbPassword.getPassword());
	}

	public String getHost() {
		return tbHost.getText();
	}

	public String getPrivateKey() {
		return tbPrivateKeyFile.getText();
	}

	public String getPrivateKeyPassword() {
		return new String(tbKeyPassword.getPassword());
	}
}
