import java.util.*;

import javax.swing.table.AbstractTableModel;
import SecureBlackbox.SFTPServer.*;


public class ConTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 1L;
	public static final int REMOTE_INDEX = 0;
	public static final int USER_INDEX = 1;
	public static final int TUNNELS_INDEX = 2;
	public static final int START_TIME_INDEX = 3;
	public static final int SOFTWARE_INDEX = 4;

	protected Vector<ConDataRow> dataVector = new Vector<ConDataRow>();
	
    protected String[] columnNames = {
    		"Remote host", 
    		"User",
    		"Tunnels",
    		"Start time",
    		"Software"
    };

	public int getColumnCount() {
		return columnNames.length;
	}

 	public String getColumnName(int column) {
        return columnNames[column];
    }

 	public Class<?> getColumnClass(int column) {
       	return String.class;
    }

	public int getRowCount() {
		return dataVector.size();
	}

    public void setValueAt(Object value, int row, int column) {
      	 ConDataRow record = (ConDataRow)dataVector.get(row);
           switch (column) {
               case REMOTE_INDEX:
                  record.RemoteHost = (String)value;
                  break;
               case USER_INDEX:
                   record.User = (String)value;
                   break;
               case TUNNELS_INDEX:
                   record.Tunnels = (String)value;
                   break;
               case START_TIME_INDEX:
                   record.StartTime = (String)value;
                   break;
               case SOFTWARE_INDEX:
                   record.Software = (String)value;
                   break;
               default:
                  System.out.println("invalid index");
           }
           fireTableCellUpdated(row, column);
       } 	
	
	public Object getValueAt(int row, int col) {
        ConDataRow record = (ConDataRow)dataVector.get(row);
        switch (col) {
	        case REMOTE_INDEX:
	        	return record.RemoteHost;
            case USER_INDEX:
            	return record.User;
            case TUNNELS_INDEX:
            	return record.Tunnels;
            case START_TIME_INDEX:
            	return record.StartTime;
            case SOFTWARE_INDEX:
            	return record.Software;                
            default:
            	return new Object();
        }
	}

	public void addRow(TElSimpleSFTPServerSessionThread session) {
    	dataVector.addElement(new ConDataRow(session.getSocket().getRemoteAddress(), 
    			session.getSSHServer().getUserName(), 
    			"Connected", 
    			new Date().toString(), 
    			session.getSSHServer().getClientSoftwareName(), session));
    	fireTableDataChanged();
	}

	public void removeRowSession(TElSimpleSFTPServerSessionThread session) {
		Vector<ConDataRow> result = new Vector<ConDataRow>();

		for (int i=0; i < dataVector.size(); i++) {
			if (session == dataVector.get(i).Tag)
				continue;
			result.add(dataVector.get(i));
		}
		
		dataVector.clear();
		dataVector.addAll(result);
		fireTableDataChanged();
	}
	

}
