

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import javax.swing.JTextArea;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSHClient.*;
import SecureBlackbox.SSHCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private JTextField tbHost;
	private JTextField tbUsername;
	private JPasswordField tbPassword;
	private JSpinner tbPort;
	private JTextArea editLog;
	private JTextArea editResult;

	private TElSocket clientSocket;
	private byte[] clientSocketReceiveBuf = new byte[1];
	private boolean clientSocketReceiveBufHasData = false;

	private TElSSHClient sshClient;
	private TElSSHTunnelList sshTunnelList;
	private TElLocalPortForwardSSHTunnel localPortForwardSSHTunnel;

	boolean connected = false;
	private JButton btnDoIt;
	private JButton btnConnect;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("Local Port Forward SSH Test");
		setBounds(100, 100, 557, 429);
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 230, 194);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblHost = new JLabel("Host");
		lblHost.setBounds(10, 22, 46, 14);
		panel.add(lblHost);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(150, 22, 46, 14);
		panel.add(lblPort);
		
		tbHost = new JTextField();
		tbHost.setText("127.0.0.1");
		tbHost.setBounds(10, 37, 116, 20);
		panel.add(tbHost);
		tbHost.setColumns(10);
		
		tbPort = new JSpinner();
		tbPort.setModel(new SpinnerNumberModel(new Integer(22), null, null, new Integer(1)));
		tbPort.setBounds(150, 37, 60, 20);
		panel.add(tbPort);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(34, 78, 97, 14);
		panel.add(lblUsername);
		
		tbUsername = new JTextField();
		tbUsername.setBounds(34, 93, 139, 20);
		panel.add(tbUsername);
		tbUsername.setColumns(10);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(34, 117, 87, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(34, 133, 139, 20);
		panel.add(tbPassword);
		
		btnConnect = new JButton("Connect");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				connectClick();
			}
		});
		btnConnect.setBounds(62, 164, 91, 23);
		panel.add(btnConnect);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(250, 11, 291, 153);
		getContentPane().add(scrollPane);
		
		editLog = new JTextArea();
		editLog.setEditable(false);
		scrollPane.setViewportView(editLog);
		
		btnDoIt = new JButton("Do It");
		btnDoIt.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doitClick();
			}
		});
		btnDoIt.setBounds(250, 175, 91, 23);
		getContentPane().add(btnDoIt);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 216, 529, 176);
		getContentPane().add(scrollPane_1);
		
		editResult = new JTextArea();
		editResult.setEditable(false);
		scrollPane_1.setViewportView(editResult);

		init();
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		sshTunnelList = new TElSSHTunnelList();

		sshClient = new TElSSHClient();
		sshClient.setAuthenticationTypes(SBSSHConstants.SSH_AUTH_TYPE_PASSWORD | SBSSHConstants.SSH_AUTH_TYPE_KEYBOARD);
		sshClient.setCompressionLevel(6);
		sshClient.setForceCompression(false);
		sshClient.setSoftwareName("EldoS_SSH");
		sshClient.setTunnelList(sshTunnelList);
		sshClient.setVersions(SBSSHCommon.sbSSH2);

		sshClient.setOnAuthenticationFailed(new TSSHAuthenticationFailedEvent(sshClient_OnAuthenticationFailed));
		sshClient.setOnAuthenticationSuccess(new TNotifyEvent(sshClient_OnAuthenticationSuccess));
		sshClient.setOnAuthenticationKeyboard(new TSSHAuthenticationKeyboardEvent(sshClient_OnAuthenticationKeyboard));
		sshClient.setOnCloseConnection(new TSSHCloseConnectionEvent(sshClient_OnCloseConnection));
		sshClient.setOnError(new TSSHErrorEvent(sshClient_OnError));
		sshClient.setOnOpenConnection(new TSSHOpenConnectionEvent(sshClient_OnOpenConnection));
		sshClient.setOnReceive(new TSSHReceiveEvent(sshClient_OnReceive));
		sshClient.setOnSend(new TSSHSendEvent(sshClient_OnSend));
		sshClient.setOnKeyValidate(new TSSHKeyValidateEvent(sshClient_OnKeyValidate));

		localPortForwardSSHTunnel = new TElLocalPortForwardSSHTunnel();
		localPortForwardSSHTunnel.setTunnelList(sshTunnelList);
		
		localPortForwardSSHTunnel.setOnClose(new TTunnelEvent(localPortForwardSSHTunnel_OnClose));
		localPortForwardSSHTunnel.setOnError(new TTunnelErrorEvent(localPortForwardSSHTunnel_OnError));
		localPortForwardSSHTunnel.setOnOpen(new TTunnelEvent(localPortForwardSSHTunnel_OnOpen));		
	}

	TSSHAuthenticationFailedEvent.Callback sshClient_OnAuthenticationFailed = new TSSHAuthenticationFailedEvent.Callback() {
		
		public void tsshAuthenticationFailedEventCallback(TObject sender, int authenticationType) {
			LogEvent("Authentication failed for type " + authenticationType);			
		}
	};
	
	TNotifyEvent.Callback sshClient_OnAuthenticationSuccess = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			LogEvent("Authentication succeeded");
		}
	};
	
	TSSHAuthenticationKeyboardEvent.Callback sshClient_OnAuthenticationKeyboard = new TSSHAuthenticationKeyboardEvent.Callback() {
		
		public void tsshAuthenticationKeyboardEventCallback(TObject sender,
				TElStringList prompts, boolean[] echo, TElStringList responses) {
			responses.clear();
			for (int i = 0; i < prompts.getCount(); i++)
			{
				TSBString response = new TSBString();				
				if (prompt((String) prompts.get(i), echo[i], response))
					responses.add(response.value);
				else
					responses.add("");
			}
		}
	};
	
	private boolean prompt(String cap, boolean echo, TSBString response) {
		int result;
		if (echo)
		{
			JTextField jpf = new JTextField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = jpf.getText();
		} else {
			JPasswordField jpf = new JPasswordField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = new String(jpf.getPassword());				
		}

		return (result == 0);
	}
	
	TSSHCloseConnectionEvent.Callback sshClient_OnCloseConnection = new TSSHCloseConnectionEvent.Callback() {
		
		public void tsshCloseConnectionEventCallback(TObject sender) {
			LogEvent("SSH connection closed");
			reset();			
		}
	};
	
	TSSHErrorEvent.Callback sshClient_OnError = new TSSHErrorEvent.Callback() {
		
		public void tsshErrorEventCallback(TObject sender, int errCode) {
			LogEvent("Error " + errCode);
		}
	};
	
	TSSHOpenConnectionEvent.Callback sshClient_OnOpenConnection = new TSSHOpenConnectionEvent.Callback() {
		
		public void tsshOpenConnectionEventCallback(TObject sender) {
			LogEvent("SSH connection established");
		}
	};
	
	TSSHReceiveEvent.Callback sshClient_OnReceive = new TSSHReceiveEvent.Callback() {
		
		public void tsshReceiveEventCallback(TObject sender, byte[] buffer, int maxSize, TSBInteger written) {
			if (clientSocketReceiveBufHasData){

			try
			{
				if (maxSize > 0)
				{
					buffer[0] = clientSocketReceiveBuf[0];
					clientSocketReceiveBufHasData = false;
					written.value += 1;
					maxSize--;
					int size = Math.min(buffer.length, maxSize);
					if (size > 0)
						clientSocket.receive(buffer, size, written);
				}
			}
			catch(Exception ex)
			{
				showErrorMessage(ex);
				reset();
			}
			
			}
		}
	};
	
	TSSHSendEvent.Callback sshClient_OnSend = new TSSHSendEvent.Callback() {
		
		public void tsshSendEventCallback(TObject sender, byte[] buffer) {
			try
			{
				clientSocket.send(buffer, 0, buffer.length, new TSBInteger());
			}
			catch(Exception ex)
			{
				showErrorMessage(ex);
				reset();
			}			
		}
	};
	
	TSSHKeyValidateEvent.Callback sshClient_OnKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		public void tsshKeyValidateEventCallback(TObject sender, TElSSHKey arg1, TSBBoolean accept) {
			LogEvent("Server key received");			
			accept.value = true; // NEVER do this. You MUST check the key validity somehow
		}
	};
	
	TTunnelEvent.Callback localPortForwardSSHTunnel_OnClose = new TTunnelEvent.Callback() {
		
		public void tTunnelEventCallback(TObject sender, TElSSHTunnelConnection arg1) {
			LogEvent("Tunnel connection closed");	
		}
	}; 
	
	TTunnelErrorEvent.Callback localPortForwardSSHTunnel_OnError = new TTunnelErrorEvent.Callback() {
		
		public void tTunnelErrorEventCallback(TObject sender, int errorCode, TObject data) {
			LogEvent("Tunnel error " + errorCode);
		}
	};
	
	TTunnelEvent.Callback localPortForwardSSHTunnel_OnOpen = new TTunnelEvent.Callback() {
		
		public void tTunnelEventCallback(TObject sender, TElSSHTunnelConnection tunnelConnection) {
			LogEvent("Tunnel Connection Opened");
			tunnelConnection.setOnData(new TSSHDataEvent(TunnelConnection_OnData));
			tunnelConnection.setOnClose(new TSSHChannelCloseEvent(TunnelConnection_OnClose));
			byte[] buf = new String("GET / HTTP/1.0\r\n\r\n").getBytes();
			tunnelConnection.sendData(buf);		
		}
	}; 
	
	TSSHChannelCloseEvent.Callback TunnelConnection_OnClose = new TSSHChannelCloseEvent.Callback() {
		
		public void tsshChannelCloseEventCallback(TObject sender, TSSHCloseType closeType) {
            LogEvent("Tunnel connection closed");
		}
	};
	
	TSSHDataEvent.Callback TunnelConnection_OnData = new TSSHDataEvent.Callback() {
		
		public void tsshDataEventCallback(TObject sender, byte[] buffer) {
			editResult.setText(editResult.getText() + new String(buffer));
		}
	};
	
	protected void doitClick() {
		localPortForwardSSHTunnel.open(null);
	}

	protected void connectClick() {
		if (!connected)
		{
			connected = true;
			editLog.setText("");
			editResult.setText("");
			try
			{
				LogEvent("Opening listening socket");				

				sshClient.setUserName(tbUsername.getText());
				sshClient.setPassword(new String(tbPassword.getPassword()));

				localPortForwardSSHTunnel.setPort(83);
				localPortForwardSSHTunnel.setToHost("www.google.com");
				localPortForwardSSHTunnel.setToPort(80);

				LogEvent("Connecting to host " + tbHost.getText());
				clientSocket = new TElSocket();
				clientSocket.setAddress(tbHost.getText());
				clientSocket.setPort(((Integer)tbPort.getValue()).intValue());
				beginConect();
			}
			catch(Exception ex)
			{
				showErrorMessage(ex);
				reset();
				return;
			}
		}
		else
		{
			reset();
		}
	}
	
	private void beginConect() {
		try
		{
	  		if (clientSocket.connect(5000) == 0) {  			
				btnConnect.setText("Stop");            
				
				java.lang.Thread t = new java.lang.Thread(new Runnable() {
					
					public void run() {
						beginReceive();			
					}
				});
				
				t.start();
				
	  			sshClient.open();

	  		} else {
	  			showErrorMessage("Failed to connect socket to the port");
	  		}
		}
		catch(Exception ex)
		{
			showErrorMessage(ex);
			reset();
			return;
		}		
	}

	private void beginReceive() {
		try
		{	
			if (isClientSocketConnected())
			{
				TSBInteger receiveLen = new TSBInteger();

				if (clientSocket.canReceive(10000))
					clientSocket.receive(clientSocketReceiveBuf, clientSocketReceiveBuf.length, receiveLen);
				
				if (receiveLen.value == 0)
				{
					showErrorMessage("Connection lost");
					reset();
					return;
				}
	
				if (receiveLen.value > 0)
					clientSocketReceiveBufHasData = true;
				
				while (true)
				{
					sshClient.dataAvailable();
					if (clientSocketReceiveBufHasData)
						java.lang.Thread.sleep(1);
					else
					{
						beginReceive();
						break;
					}
				}			
			}
		}
		catch(Exception ex)
		{
			if (isClientSocketConnected())
			{
				showErrorMessage(ex);
				reset();
			}
		}
	}

	private boolean isClientSocketConnected() {
		if (clientSocket == null) return false;
		return clientSocket.getState() == SBSocket.issConnected;
	}

	private void showErrorMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}

	private void showErrorMessage(Exception ex) {
		JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
	}

	private void reset()
	{
		if (!connected)
			return;
		connected = false;

		btnConnect.setText("Connect");
		
		if (sshClient.getActive())
			sshClient.close(true);

		if (clientSocket != null)
		{
			try { clientSocket.Free(); }
			catch(Exception ex) {}
			finally { clientSocket = null; }
		}
		
		LogEvent("Connection closed");
	}
	
	private void LogEvent(String s)
	{
		if (editLog.getText().length() > 0)
			editLog.setText(editLog.getText() + "\r\n");
		editLog.setText(editLog.getText() + s);
	}
}
