

import java.awt.EventQueue;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JSeparator;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.Date;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTable;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.ESecureBlackboxError;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TElStringList;
import SecureBlackbox.Base.TNotifyEvent;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.Base.TSBString;
import SecureBlackbox.SSHClient.*;
import SecureBlackbox.SSHCommon.*;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class Main extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	private TElSimpleSSHClient client;
	private TElSSHMemoryKeyStorage KeyStorage;
	private javax.swing.Timer timer = null; 
	private JTextField tbSendText;
	private JTable tableLog;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("SimpleSSHClient Demo Application");
		setBounds(100, 100, 761, 530);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnConnection = new JMenu("Connection");
		menuBar.add(mnConnection);
		
		JMenuItem mntmConnect = new JMenuItem("Connect");
		mntmConnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Connect();
			}
		});
		mnConnection.add(mntmConnect);
		
		JMenuItem mntmDisconnect = new JMenuItem("Disconnect");
		mntmDisconnect.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Disconnect();
			}
		});
		mnConnection.add(mntmDisconnect);
		
		JSeparator separator = new JSeparator();
		mnConnection.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mnConnection.add(mntmExit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AboutDialog dlg = new AboutDialog();
				dlg.setVisible(true);
				dlg.setModal(true);
			}
		});
		mnHelp.add(mntmAbout);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		getContentPane().add(toolBar, BorderLayout.NORTH);
		
		JButton btnConnect = new JButton("");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Connect();
			}
		});
		btnConnect.setIcon(getIcon("connect"));
		toolBar.add(btnConnect);
		
		JButton btnDisconnect = new JButton("");
		btnDisconnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Disconnect();
			}
		});
		btnDisconnect.setIcon(getIcon("disconnect"));
		toolBar.add(btnDisconnect);
		
		JPanel panel = new JPanel();
		getContentPane().add(panel, BorderLayout.CENTER);
		panel.setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(0, 0, 753, 315);
		panel.add(scrollPane);
		
		tbView = new JTextArea();
		tbView.setLineWrap(true);
		tbView.setWrapStyleWord(true);
		scrollPane.setViewportView(tbView);
		
		tbSendText = new JTextField();
		tbSendText.setBounds(10, 326, 631, 20);
		panel.add(tbSendText);
		tbSendText.setColumns(10);
		
		JButton btnSend = new JButton("Send");
		btnSend.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Send(tbSendText.getText());
			}
		});
		btnSend.setBounds(651, 326, 91, 23);
		panel.add(btnSend);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(0, 355, 753, 99);
		panel.add(scrollPane_1);
		
		tableLog = new JTable(new LogTableModel());
		tableLog.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(tableLog);

		init();
	}
	
	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		KeyStorage = new TElSSHMemoryKeyStorage();
		
		client = new TElSimpleSSHClient();
		client.setKeyStorage(KeyStorage);
        
	    client.setOnAuthenticationFailed(new TSSHAuthenticationFailedEvent(client_OnAuthenticationFailed));
	    client.setOnKeyValidate(new TSSHKeyValidateEvent(client_OnKeyValidate));
	    client.setOnAuthenticationKeyboard(new TSSHAuthenticationKeyboardEvent(client_OnAuthenticationKeyboard));
	    client.setOnBanner(new TSSHBannerEvent(client_OnBanner));
	    client.setOnCloseConnection(new TSSHCloseConnectionEvent(client_OnCloseConnection));
	    client.setOnAuthenticationSuccess(new TNotifyEvent(client_OnAuthenticationSuccess));
	    client.setOnError(new TSSHErrorEvent(client_OnError));
	}
	
	TSSHAuthenticationFailedEvent.Callback client_OnAuthenticationFailed = new TSSHAuthenticationFailedEvent.Callback() {
		
		public void tsshAuthenticationFailedEventCallback(TObject sender, int AuthenticationType) {
			Log("Authentication type (" + AuthenticationType + ") failed", true); 			
		}
	};
	
	TSSHKeyValidateEvent.Callback client_OnKeyValidate = new TSSHKeyValidateEvent.Callback() {
		
		public void tsshKeyValidateEventCallback(TObject sender, TElSSHKey ServerKey, TSBBoolean accept) {
			Log("Server key received, fingerprint " + SBUtils.digestToStr128(ServerKey.getFingerprintMD5(), true), false);
			accept.value = true;
		}
	};
	
	TSSHAuthenticationKeyboardEvent.Callback client_OnAuthenticationKeyboard = new TSSHAuthenticationKeyboardEvent.Callback() {
		
		
		public void tsshAuthenticationKeyboardEventCallback(TObject sender,
				TElStringList prompts, boolean[] echo, TElStringList responses) {
			responses.clear();
			for (int i = 0; i < prompts.getCount(); i++)
			{
				TSBString response = new TSBString();				
				if (prompt((String) prompts.get(i), echo[i], response))
					responses.add(response.value);
				else
					responses.add("");
			}
		}
	};

	private boolean prompt(String cap, boolean echo, TSBString response) {
		int result;
		if (echo)
		{
			JTextField jpf = new JTextField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = jpf.getText();
		} else {
			JPasswordField jpf = new JPasswordField();
			result = JOptionPane.showConfirmDialog(null, jpf, cap, JOptionPane.OK_CANCEL_OPTION);
			response.value = new String(jpf.getPassword());				
		}

		return (result == 0);
	}
	
	TSSHBannerEvent.Callback client_OnBanner = new TSSHBannerEvent.Callback() {
		
		public void tsshBannerEventCallback(TObject sender, byte[] Text, byte[] Language) {
			try {
				throw new ESecureBlackboxError(SBUtils.stringOfBytes(Text));
			} catch (ESecureBlackboxError e) {
				Log(e.getMessage(), true);
			}			
		}
	};
	
	TSSHCloseConnectionEvent.Callback client_OnCloseConnection = new TSSHCloseConnectionEvent.Callback() {
		
		public void tsshCloseConnectionEventCallback(TObject sender) {
			timer.stop();
			Log("SSH connection closed", false);
		}
	};
	
	TNotifyEvent.Callback client_OnAuthenticationSuccess = new TNotifyEvent.Callback() {
		
		public void tNotifyEventCallback(TObject sender) {
			Log("Authentication succeeded", false);
		}
	};
	
	TSSHErrorEvent.Callback client_OnError = new TSSHErrorEvent.Callback() {
		
		public void tsshErrorEventCallback(TObject sender, int ErrorCode) {
			Log("SSH error " + ErrorCode, true);			
		}
	};
	private JTextArea tbView;
	
	private void Connect() 
	{
		ConPropsDialog dlg = new ConPropsDialog();

		if (client.getActive()) 
		{
			showMessage("Already connected");
			return;
		}

		dlg.setModal(true);
		dlg.setVisible(true);
		
		if (dlg.isOK()) 
		{
			String addr = dlg.getHost();
			int idx = addr.indexOf(':');
			if (idx > 0)
			{
				client.setAddress(addr.substring(0, idx));
				try
				{
					client.setPort(Integer.parseInt(addr.substring(idx + 1, addr.length() - (idx + 1))));
				} catch (NumberFormatException e) {
					client.setPort(22);
				}
			}
			else
			{
				client.setAddress(addr);
				client.setPort(22);
			}
			client.setUsername(dlg.getUser());
			client.setPassword(dlg.getPassword());
			client.setVersions((short)0);
			if (dlg.getSSH1()) 
			{
				client.setVersions((short) (client.getVersions() + SBSSHCommon.sbSSH1));
			}
			if (dlg.getSSH2()) 
			{
				client.setVersions((short) (client.getVersions() + SBSSHCommon.sbSSH2));
			}
			client.setForceCompression(dlg.getCompress());
			
			KeyStorage.clear();
			TElSSHKey Key = new TElSSHKey();
			if (dlg.getPrivateKey().compareTo("") != 0) 
			{
				int err = Key.loadPrivateKey(dlg.getPrivateKey(), dlg.getKeyPassword());
				if (err == 0)
				{
					KeyStorage.add(Key);
					client.setAuthenticationTypes(client.getAuthenticationTypes() | SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY);
				}
				else
				{
					client.setAuthenticationTypes(client.getAuthenticationTypes() & (~SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY));
					Log("Private key file could not be loaded due to error " + err, true);
				}
			}
			else
			{
				client.setAuthenticationTypes(client.getAuthenticationTypes() & (~SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY));
			}
			Log("Connecting to " + dlg.getHost() + "...", false);
			try 
			{

				try
				{
					client.open();
				}
				catch (Exception e)
				{
					Log("Connection failed due to exception: " + e.getMessage(), true);
					Log("If you have ensured that all connection parameters are correct and you still can't connect,", true);
					Log("please contact EldoS support as described on http://www.eldos.com/sbb/support-tech.php", true);
					Log("Remember to provide details about the error that happened.", true);
					if (client.getServerSoftwareName().length() > 0)
					{
						Log("Server software identified itself as: " + client.getServerSoftwareName(), true);
					}
					try
					{
						client.close(true);
					}
					catch(Exception ex)
					{
					}
					return;
				}


				timer = new javax.swing.Timer(1000, this);
				timer.start();	
			} 
			catch(Exception ex) 
			{
				Log("SSH connection failed", true);
				return;
			}

			Log("SSH connection established", false);				
		}
	}

	private void showMessage(String msg) {
		JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.ERROR_MESSAGE);		
	}

	private void Disconnect()
	{
		if (client.getActive()) 
		{
			Log("Disconnecting", false);
			client.close();
		}
	}

	private void Send(String Data) 
	{
		byte[] encoded = new String(Data + "\n\r").getBytes();
		client.sendData(encoded, encoded.length);
	}

	protected void Log(String s, boolean b) {
		LogTableModel model = (LogTableModel)tableLog.getModel();
		model.addRow(new Date(), s, b ? "E" : "I");
	}

	public void actionPerformed(ActionEvent e) {
		boolean canRecv = true;
		byte[] data = new byte[65280];
		byte[] dataErr = new byte[65280];
		TSBInteger dataLen = new TSBInteger();
		TSBInteger dataErrLen = new TSBInteger();

		while (canRecv)
		{
			try
			{
				canRecv = client.canReceive(0);
			}
			catch(Exception ex)
			{
				canRecv = false;
			}

			if (canRecv)
			{
				try
				{
					dataLen.value = data.length;
					dataErrLen.value = dataErr.length;
					client.receiveData(data, dataLen, dataErr, dataErrLen);
					
					if (dataLen.value > 0)
						tbView.setText(tbView.getText() + new String(data, 0, dataLen.value));

					if (dataErrLen.value > 0)
						tbView.setText(tbView.getText() + new String(dataErr, 0, dataErrLen.value));
					
				}
				catch (Exception ex)
				{
					canRecv = false;
				}
			}

			if (!client.getActive())
				timer.stop();
		}		
	}	
	
}
