import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JCheckBox;
import javax.swing.JTextArea;

import javax.swing.JScrollPane;
import javax.swing.JTable;

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.SSHCommon.SBSSHKeyStorage;
import SecureBlackbox.SSHCommon.TElSSHKey;
import SecureBlackbox.SSHCommon.TSBSSHKeyFormat;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Arrays;


public class SettingsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edIP;
	private JTextField edPort;
	private JTable table;
	private JTextArea memHostKey;
	private JCheckBox cbForceCompression;
	private boolean isOk;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SettingsDialog dialog = new SettingsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SettingsDialog() {
		setTitle("Server Settings");
		setBounds(100, 100, 566, 393);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Server Settings", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 11, 538, 178);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JLabel lblIpAddress = new JLabel("IP Address:");
				lblIpAddress.setBounds(10, 23, 67, 14);
				panel.add(lblIpAddress);
			}
			{
				edIP = new JTextField();
				edIP.setText("127.0.0.1");
				edIP.setBounds(87, 20, 110, 20);
				panel.add(edIP);
				edIP.setColumns(10);
			}
			{
				JLabel lblPort = new JLabel("Port:");
				lblPort.setBounds(207, 23, 46, 14);
				panel.add(lblPort);
			}
			{
				edPort = new JTextField();
				edPort.setText("22");
				edPort.setBounds(243, 20, 55, 20);
				panel.add(edPort);
				edPort.setColumns(10);
			}
			{
				cbForceCompression = new JCheckBox("Force packet compression");
				cbForceCompression.setBounds(315, 19, 182, 23);
				panel.add(cbForceCompression);
			}
			{
				JButton btnGenerateNewKey = new JButton("Generate new key");
				btnGenerateNewKey.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						generateNewKeyClick();
					}
				});
				btnGenerateNewKey.setBounds(391, 49, 137, 23);
				panel.add(btnGenerateNewKey);
			}
			{
				JLabel lblHostKey = new JLabel("Host key:");
				lblHostKey.setBounds(10, 54, 98, 14);
				panel.add(lblHostKey);
			}
			
			JScrollPane scrollPane = new JScrollPane();
			scrollPane.setBounds(10, 83, 518, 84);
			panel.add(scrollPane);
			{
				memHostKey = new JTextArea();
				scrollPane.setViewportView(memHostKey);
				memHostKey.setEditable(false);
			}
		}
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Autorized users", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 200, 538, 122);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JButton btnAdd = new JButton("Add");
				btnAdd.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						addUserClick();
					}
				});
				btnAdd.setBounds(437, 22, 91, 23);
				panel.add(btnAdd);
			}
			{
				JButton btnRemove = new JButton("Remove");
				btnRemove.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						removeUserClick();
					}
				});
				btnRemove.setBounds(437, 52, 91, 23);
				panel.add(btnRemove);
			}
			{
				JButton btnEdit = new JButton("Edit");
				btnEdit.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						editUserClick();
					}
				});
				btnEdit.setBounds(437, 86, 91, 23);
				panel.add(btnEdit);
			}
			{
				JScrollPane scrollPane = new JScrollPane();
				scrollPane.setBounds(10, 22, 424, 87);
				panel.add(scrollPane);
				{
					table = new JTable(new UserTableModel());
					table.setFillsViewportHeight(true);
					scrollPane.setViewportView(table);
				}
			}
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = false;
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		init();
	}

	protected void addUserClick() {
		if (Globals.getSettings().AddUser()) 
			Globals.getSettings().EditUser(Globals.getSettings().getUsers().size() - 1);
		FillUsers();		
	}

	protected void removeUserClick() {
		if (Globals.getSettings().RemoveUser(GetUserNumber())) FillUsers();
	}

	protected void editUserClick() {
		if (Globals.getSettings().EditUser(GetUserNumber())) FillUsers();
	}

	protected void generateNewKeyClick() {
		if (chooseMessage("Do you want to generate a new host key for the server?")) {
			TElSSHKey Key = new TElSSHKey();
			Key.generate(SBSSHKeyStorage.ALGORITHM_RSA, 1024);
			byte[] SaveKey = null;
			TSBInteger SaveLen = new TSBInteger();
			Key.savePrivateKey(SaveKey, SaveLen, "");
			SaveKey = new byte[SaveLen.value];
			Key.savePrivateKey(SaveKey, SaveLen, "");
			memHostKey.setText(SBUtils.stringOfBytes(SaveKey));
			Globals.getSettings().setServerKey(memHostKey.getText());
		}
	}

	// returns the index of currently selected user 
	private int GetUserNumber()
	{
		try
		{
			UserTableModel model = (UserTableModel)table.getModel();
			return model.getUserUNumber(table.getSelectedRow());
		}
		catch(Exception ex) 
		{
			return -1;
		}
	}

	private boolean chooseMessage(String msg) {
		return (JOptionPane.showConfirmDialog(this, msg) == JOptionPane.YES_OPTION);
	}

	void init() {
		FillUsers();
		memHostKey.setText(Globals.getSettings().getServerKey());
		edIP.setText(Globals.getSettings().getServerHost());
		edPort.setText(Integer.toString(Globals.getSettings().getServerPort()));
		cbForceCompression.setSelected(Globals.getSettings().getForceCompression());		
	}
	
	// sets up users list view according to user accounts settings
	private void FillUsers()
	{
		clearUserTable();
		for (int i = 0; i < Globals.getSettings().getUsers().size(); i++)
		{
			UserInfo user = (UserInfo)Globals.getSettings().getUsers().get(i);
			user.setUNumber(i);
			addUserRow(user);
		}		
	}

	private void addUserRow(UserInfo user) {
		UserTableModel model = (UserTableModel) table.getModel();
		model.addRow(user);
	}

	private void clearUserTable() {
		UserTableModel model = (UserTableModel) table.getModel();
		model.clear();
	}
	
	// forces settings update 
	public static void ChangeSettings()
	{
		SettingsDialog frm = new SettingsDialog();
		frm.setModal(true);
		frm.setVisible(true);
		
		if (frm.isOK())
		{
			try
			{
				Globals.getSettings().SetHostKey(frm.memHostKey.getText());
				Globals.getSettings().setServerHost(frm.edIP.getText());
				Globals.getSettings().setServerPort(Integer.parseInt(frm.edPort.getText()));
				Globals.getSettings().setForceCompression(frm.cbForceCompression.isSelected());
				Globals.getSettings().SaveSettings();
			}
			catch(Exception exc)
			{
				Logger.Log("ChangeSettings : " + exc.getMessage(),true);
			}
		}
	}

	private boolean isOK() {
		return isOk;
	}
}
