

import java.awt.EventQueue;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import java.awt.BorderLayout;
import javax.swing.JButton;
import javax.swing.JSeparator;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import java.io.File;
import java.net.URL;

import javax.swing.JTable;
import javax.swing.JTextArea;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.DAVClient.*;
import SecureBlackbox.DAVCommon.TSBWebDavDepth;
import SecureBlackbox.DAVCommon.TSBWebDavLockScope;
import SecureBlackbox.SSLCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTable tbObjects;
	private TElHTTPSWebDAVClient HTTPSClient = null;
	private TElWebDAVClient WebDavClient = null;
	private ObjectsTableModel model;
	private JTextArea tbLog;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("EldoS WebDAV Client demo");
		setBounds(100, 100, 621, 409);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmCreateCollection = new JMenuItem("Create collection");
		mntmCreateCollection.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent arg0) {
				create();
			}
		});
		mnFile.add(mntmCreateCollection);
		
		JMenuItem mntmDownloadFile = new JMenuItem("Download file");
		mntmDownloadFile.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				download();
			}
		});
		mnFile.add(mntmDownloadFile);
		
		JMenuItem mntmUploadFile = new JMenuItem("Upload file");
		mntmUploadFile.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				upload();
			}
		});
		mnFile.add(mntmUploadFile);
		
		JMenuItem mntmExit = new JMenuItem("Exit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				exit();
			}
		});
		mnFile.add(mntmExit);
		
		JMenu mnHelp = new JMenu("Help");
		menuBar.add(mnHelp);
		
		JMenuItem mntmAbout = new JMenuItem("About...");
		mntmAbout.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				showMessage("SecureBlackbox WebDav client demo.\n" +
						"Visit http://www.eldos.com/sbb/ for more information!");				
			}
		});
		mnHelp.add(mntmAbout);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		getContentPane().add(toolBar, BorderLayout.NORTH);
		
		JButton btnConnect = new JButton(" ");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				connect();
			}
		});
		btnConnect.setIcon(getIcon("connect"));
		toolBar.add(btnConnect);
		
		JButton btnCreate = new JButton(" ");
		btnCreate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				create();
			}
		});
		btnCreate.setIcon(getIcon("create"));
		toolBar.add(btnCreate);
		
		JButton btnUpload = new JButton(" ");
		btnUpload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				upload();
			}
		});
		btnUpload.setIcon(getIcon("upload"));
		toolBar.add(btnUpload);
		
		JButton btnDownload = new JButton(" ");
		btnDownload.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				download();
			}
		});
		btnDownload.setIcon(getIcon("download"));
		toolBar.add(btnDownload);
		
		JButton btnRename = new JButton(" ");
		btnRename.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rename();
			}
		});
		btnRename.setIcon(getIcon("rename"));
		toolBar.add(btnRename);
		
		JButton btnCopy = new JButton(" ");
		btnCopy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				copy();
			}
		});
		btnCopy.setIcon(getIcon("copy"));
		toolBar.add(btnCopy);
		
		JButton btnDelete = new JButton(" ");
		btnDelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				delete();
			}
		});
		btnDelete.setIcon(getIcon("delete"));
		toolBar.add(btnDelete);
		
		JButton btnLock = new JButton(" ");
		btnLock.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				lock();
			}
		});
		btnLock.setIcon(getIcon("lock"));
		toolBar.add(btnLock);
		
		JButton btnUnlock = new JButton(" ");
		btnUnlock.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				unlock();
			}
		});
		btnUnlock.setIcon(getIcon("unlock"));
		toolBar.add(btnUnlock);
		
		JSeparator separator_1 = new JSeparator();
		toolBar.add(separator_1);
		
		JButton btnExit = new JButton(" ");
		btnExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				exit();
			}
		});
		btnExit.setIcon(getIcon("exit"));
		toolBar.add(btnExit);
		
		JSeparator separator = new JSeparator();
		toolBar.add(separator);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(4, 100));
		getContentPane().add(scrollPane, BorderLayout.SOUTH);
		
		tbLog = new JTextArea();
		scrollPane.setViewportView(tbLog);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		getContentPane().add(scrollPane_1, BorderLayout.CENTER);
		
		model = new ObjectsTableModel();
		tbObjects = new JTable(model);
		tbObjects.setFillsViewportHeight(true);
		scrollPane_1.setViewportView(tbObjects);

		init();
		
		initDoubleClick();
	}

	private void initDoubleClick() {
		tbObjects.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e){
			      if (e.getClickCount() == 2){
			    	  openItem();
			      }
			}
		});
	}

	protected void openItem() {
		TElWebDAVStorageObject O;

		if (tbObjects.getSelectedRowCount() > 0)
		{
			
			O = (TElWebDAVStorageObject)model.getTag(tbObjects.getSelectedRow());
			if (O.getCollection())
				List(O);
		}
	}

	private void showMessage(String msg) {
    	JOptionPane.showMessageDialog(null, msg, getTitle(), JOptionPane.INFORMATION_MESSAGE);
	}

	protected void exit() {
		dispose();
	}

	protected void unlock() {
		if (tbObjects.getSelectedRowCount() > 0)
		{
			((TElWebDAVStorageObject)model.getTag(tbObjects.getSelectedRow())).unlock();
			List(null);
		}
	}

	protected void lock() {
		if (tbObjects.getSelectedRowCount() > 0)
		{
			((TElWebDAVStorageObject)model.getTag(tbObjects.getSelectedRow())).lock(TSBWebDavLockScope.wlsExclusive, TSBWebDavDepth.wddInfinity, 0); 
			List(null);
		}
	}

	protected void delete() {
		if (tbObjects.getSelectedRowCount() > 0)
		{
			WebDavClient.deleteObject((TElWebDAVStorageObject) model.getTag(tbObjects.getSelectedRow()), null);
			List(null);
		}		
	}

	protected void copy() {
		String q = requestQuery();
		if ((q.length() > 0)&& (tbObjects.getSelectedRowCount() > 0))
		{
			WebDavClient.copyObject(((TElWebDAVStorageObject)model.getTag(tbObjects.getSelectedRow())).getFullURL(), q, false, null, null);
			List(null);
		}		
	}

	protected void rename() {
		String q = requestQuery();
		if ((q.length() > 0)&& (tbObjects.getSelectedRowCount() > 0))
		{
			WebDavClient.rename((TElWebDAVStorageObject) model.getTag(tbObjects.getSelectedRow()), q, true);
			List(null);
		}
	}

	protected void download() {
		String fileName = getSaveFileName();
		if ((fileName.length() > 0) && (tbObjects.getSelectedRowCount() > 0))
		{
			WebDavClient.downloadFile(((TElWebDAVStorageObject)model.getTag(tbObjects.getSelectedRow())).getFullURL(), fileName);
		}
	}

	private String getSaveFileName() {
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";

	}

	protected void upload() {
		String fileName = getFileName();
		if (fileName.length() > 0)
		{
			TElWebDavErrorList Errors = new TElWebDavErrorList();

			File file = new File(fileName);
			WebDavClient.uploadFile(fileName, WebDavClient.getLastListedURL() +
				file.getName(), null, Errors);

			for (int i = 0; i < Errors.getCount(); i++)
			{
				tbLog.setText(tbLog.getText() + "URL: " + Errors.getObject(i).getURL() + ", Status: " + Errors.getObject(i).getStatus() + "\n");
			}

			List(null);
		}		
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	protected void create() {
		String query = requestQuery();
		if (query.length() > 0) {
			WebDavClient.createCollection(WebDavClient.getLastListedURL() + query, null);
			List(null);
		}
	}
	
 	private String requestQuery() {
		JTextField jpf = new JTextField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Input query", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getText());
		return "";
	}	

	protected void connect() {
		LoginForm frmLogin = new LoginForm();
		frmLogin.setModal(true);
		frmLogin.setVisible(true);
		if (!frmLogin.isOK())
			return;

		HTTPSClient = new TElHTTPSWebDAVClient();
		HTTPSClient.setOnCertificateValidate(new TSBCertificateValidateEvent(DoCertificateValidate));
		HTTPSClient.setOnError(new TSBErrorEvent(DoError));
		HTTPSClient.getRequestParameters().setUsername(frmLogin.getUsername());
		HTTPSClient.getRequestParameters().setPassword(frmLogin.getPassword());
		HTTPSClient.setHTTPVersion(TSBHTTPVersion.hvHTTP11);

		WebDavClient = new TElWebDAVClient();
		WebDavClient.setHTTPSWebDAVClient(HTTPSClient);
		WebDavClient.setOwner("http://box.com");
		WebDavClient.setBaseURL(frmLogin.getURL());

		List(null);		
	}

	protected void List(TElWebDAVStorageObject Obj)
	{
		TElWebDavObjectList ObjList = new TElWebDavObjectList();
		TElWebDAVStorageObject O;
		int i;

		try
		{
			if (Obj == null)
				WebDavClient.list(ObjList);
			else
				WebDavClient.list(Obj, ObjList);
			
			for (i = 0; i < tbObjects.getRowCount(); i++)
			{
				O = (TElWebDAVStorageObject)model.getTag(i);
				O.Free();
			}
			
			model.clear();

			for (i = 0; i < ObjList.getCount(); i++)
				model.addItem(ObjList.getObject(i));
		}
		finally
		{
		}
	}
	
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".png");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}
	
	// events
	
	TSBErrorEvent.Callback DoError = new TSBErrorEvent.Callback() {
		
		public void tsbErrorEventCallback(TObject arg0, int ErrorCode, boolean Fatal,
				boolean Validate) {
			tbLog.setText( tbLog.getText() + "ErrorCode: " + ErrorCode + "\n");
		}
	};
	
	TSBCertificateValidateEvent.Callback DoCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject arg0,
				TElX509Certificate X509Certificate, TSBBoolean accept) {
			// NEVER do this in production code. Instead perform full certificate validation.
			// You can use TElX509CertificateValidator class for complete certificiate chain validation. 
			// See other samples for example of how TElX509CertificateValidator class should be used.
			accept.value = true;
		}
	};
}
