import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.ButtonGroup;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.JRadioButton;
import javax.swing.JPasswordField;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.XML.*;
import SecureBlackbox.XMLSecurity.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JCheckBox;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;


public class SignDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edKeyName;
	private JTextField edKeyFile;
	private JPasswordField edPassphrase;
	boolean isOk;
	private JButton sbKeyFile;
	private JLabel lblPassphrase;
	private JButton btnReferences;
	private JButton btnNewButton;
	private JTextField edCertSerial;
	RefsDialog frmReferences;
	private JCheckBox chbIncludeKey;
	private JComboBox<String> cmbSignatureType;
	private JRadioButton rbHMACMethod;
	private JRadioButton rbSignatureMethod;
	private JLabel lblSignatureType;
	private JComboBox<String> cmbCanonMethod;
	private JComboBox<String> cmbHMACMethod;
	private JComboBox<String> cmbSignatureMethod;
	public XAdESDialog frmXAdES;
	public SelWinCertDialog frmSelWinCert;
	private JLabel lbHMACMethod;
	private JLabel lbSignatureMethod;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SignDialog dialog = new SignDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SignDialog() {
		frmReferences = new RefsDialog();
		frmXAdES = new XAdESDialog();
		frmSelWinCert = new SelWinCertDialog();
		frmXAdES.setLocationRelativeTo(this);
		frmSelWinCert.setLocationRelativeTo(this);
		frmReferences.setLocationRelativeTo(this);
		
		setTitle("Signature Options");
		setBounds(100, 100, 421, 550);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "General", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 393, 232);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBounds(10, 75, 373, 84);
		panel.add(panel_1);
		panel_1.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Signature method type", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setLayout(null);
		
		rbHMACMethod = new JRadioButton("HMAC method");
		rbHMACMethod.setBounds(6, 22, 109, 23);
		panel_1.add(rbHMACMethod);
		
		rbSignatureMethod = new JRadioButton("Signature method");
		rbSignatureMethod.setSelected(true);
		rbSignatureMethod.setBounds(6, 48, 160, 23);
		panel_1.add(rbSignatureMethod);

		ButtonGroup group = new ButtonGroup();
		group.add(rbHMACMethod);
		group.add(rbSignatureMethod);
		
		lblSignatureType = new JLabel("Signature type");
		lblSignatureType.setBounds(10, 23, 117, 14);
		panel.add(lblSignatureType);
		
		JLabel lblCanonicalizationMethod = new JLabel("Canonicalization method");
		lblCanonicalizationMethod.setBounds(10, 48, 144, 14);
		panel.add(lblCanonicalizationMethod);
		
		cmbSignatureType = new JComboBox<String>();
		cmbSignatureType.setModel(new DefaultComboBoxModel<String>(new String[] {"Enveloped", "Enveloping", "Detached"}));
		cmbSignatureType.setBounds(164, 19, 219, 22);
		panel.add(cmbSignatureType);
		
		cmbCanonMethod = new JComboBox<String>();
		cmbCanonMethod.setModel(new DefaultComboBoxModel<String>(new String[] {"Canonical", "Canonical +comments", "Minimal"}));
		cmbCanonMethod.setBounds(164, 44, 219, 22);
		panel.add(cmbCanonMethod);
		
		lbHMACMethod = new JLabel("HMAC method");
		lbHMACMethod.setBounds(20, 171, 107, 14);
		panel.add(lbHMACMethod);
		
		cmbHMACMethod = new JComboBox<String>();
		cmbHMACMethod.setModel(new DefaultComboBoxModel<String>(new String[] {"MD5", "SHA1", "SHA224", "SHA256", "SHA384", "SHA512", "RIPEMD160"}));
		cmbHMACMethod.setBounds(164, 170, 219, 22);
		panel.add(cmbHMACMethod);
		
		lbSignatureMethod = new JLabel("Signature method");
		lbSignatureMethod.setBounds(20, 196, 107, 14);
		panel.add(lbSignatureMethod);
		
		cmbSignatureMethod = new JComboBox<String>();
		cmbSignatureMethod.setModel(new DefaultComboBoxModel<String>(new String[] {"DSS", "RSA SHA1", "RSA MD5", "RSA SHA256", "RSA SHA384", "RSA SHA512", "RSA RIPEMD160"}));
		cmbSignatureMethod.setBounds(164, 194, 219, 22);
		panel.add(cmbSignatureMethod);
				
		JPanel panel_3 = new JPanel();
		panel_3.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Key Info", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_3.setBounds(10, 288, 393, 191);
		contentPanel.add(panel_3);
		panel_3.setLayout(null);
		
		JLabel lblKeyName = new JLabel("Key Name");
		lblKeyName.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyName.setBounds(10, 52, 81, 14);
		panel_3.add(lblKeyName);
		
		JLabel lblKeyFile = new JLabel("Key file");
		lblKeyFile.setHorizontalAlignment(SwingConstants.RIGHT);
		lblKeyFile.setBounds(10, 86, 81, 14);
		panel_3.add(lblKeyFile);
		
		lblPassphrase = new JLabel("Passphrase");
		lblPassphrase.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPassphrase.setBounds(10, 146, 81, 14);
		panel_3.add(lblPassphrase);
		
		edKeyName = new JTextField();
		edKeyName.setBounds(101, 49, 242, 20);
		panel_3.add(edKeyName);
		edKeyName.setColumns(10);
		
		edKeyFile = new JTextField();
		edKeyFile.setBounds(101, 80, 242, 20);
		panel_3.add(edKeyFile);
		edKeyFile.setColumns(10);
		
		sbKeyFile = new JButton("New button");
		sbKeyFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				edKeyFile.setText(getFileName());
			}
		});
		sbKeyFile.setBounds(346, 79, 37, 23);
		panel_3.add(sbKeyFile);
		
		edPassphrase = new JPasswordField();
		edPassphrase.setBounds(101, 143, 242, 20);
		panel_3.add(edPassphrase);
		
		JLabel lblWinCert = new JLabel("Win Cert");
		lblWinCert.setHorizontalAlignment(SwingConstants.RIGHT);
		lblWinCert.setBounds(10, 118, 81, 14);
		panel_3.add(lblWinCert);
		
		edCertSerial = new JTextField();
		edCertSerial.setColumns(10);
		edCertSerial.setBounds(101, 112, 242, 20);
		panel_3.add(edCertSerial);
		
		JButton btnWinCertBrowse = new JButton("New button");
		btnWinCertBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				winCertBrowseClick();
			}
		});
		btnWinCertBrowse.setBounds(346, 111, 37, 23);
		panel_3.add(btnWinCertBrowse);
		
		chbIncludeKey = new JCheckBox("Include Key (public part)");
		chbIncludeKey.setSelected(true);
		chbIncludeKey.setBounds(33, 19, 166, 23);
		panel_3.add(chbIncludeKey);
		
		btnNewButton = new JButton("XAdES Options");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showXAdESDialog();
			}
		});
		btnNewButton.setBounds(20, 254, 124, 23);
		contentPanel.add(btnNewButton);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				
				btnReferences = new JButton("References");
				btnReferences.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						showReferencesDialog();
					}
				});
				buttonPane.add(btnReferences);
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}

		addWindowListener(new WindowAdapter() {
			@Override
			public void windowActivated(WindowEvent e) {
				updateOpt();
			}
		});

		rbHMACMethod.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				updateOpt();
			}
		});
		rbSignatureMethod.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				updateOpt();
			}
		});
				
		setCanonicalizationMethod(SBXMLDefs.xcmCanon);
		setSignatureType(SBXMLSec.xstEnveloped);
		setSignatureMethodType(SBXMLSec.xmtSig);
		setHMACMethod(SBXMLSec.xmmHMAC_SHA1);
		setSigMethod(SBXMLSec.xsmRSA_SHA1);
	}

	protected void winCertBrowseClick() {
		frmSelWinCert.setLocationRelativeTo(this);
		frmSelWinCert.setModal(true);
		frmSelWinCert.setVisible(true);
		if ((frmSelWinCert.isOK()) && (frmSelWinCert.getSelWinCertificate() != null))
			edCertSerial.setText(SBUtils.binaryToString(frmSelWinCert.getSelWinCertificate().getSerialNumber()));
		else
			edCertSerial.setText("");		
	}

	public boolean isOK() {
		return isOk;
	}

	public void updateOpt() {
		cmbHMACMethod.setEnabled(rbHMACMethod.isSelected());
		lbHMACMethod.setEnabled(cmbHMACMethod.isEnabled());
		cmbSignatureMethod.setEnabled(rbSignatureMethod.isSelected());
		lbSignatureMethod.setEnabled(cmbSignatureMethod.isEnabled());
		edPassphrase.setEnabled(cmbSignatureMethod.isEnabled());
		lblPassphrase.setEnabled(edPassphrase.isEnabled());
	}
	
	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	String getSaveFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public void setReferenceDocument(TElXMLDOMDocument doc) {
		frmReferences.setRefDocument(doc);
	}
	
	public void setReferences(TElXMLReferenceList refs) {
		frmReferences.setReferences(refs);		
	}

	public void setReferencesVerify(boolean b) {
		frmReferences.setVerify(b);
	}

	public void setIncludeKey(boolean b) {
		chbIncludeKey.setSelected(b);
	}

	public short getSignatureType() {
		switch (cmbSignatureType.getSelectedIndex())
		{
			case 1: return SBXMLSec.xstEnveloping;
			case 2: return SBXMLSec.xstDetached;
			default: return SBXMLSec.xstEnveloped;
		}
	}

	public short getCanonicalizationMethod() {
		switch (cmbCanonMethod.getSelectedIndex())
		{
			case 0: return SBXMLDefs.xcmCanon;
			case 1: return SBXMLDefs.xcmCanonComment;
			case 2: return SBXMLDefs.xcmMinCanon;
			default: return SBXMLDefs.xcmCanon;
		}	
	}

	public short getSignatureMethodType() {
		if (rbHMACMethod.isSelected())
			return SBXMLSec.xmtMAC;

		return SBXMLSec.xmtSig;
	}

	public short getSigMethod() {
		switch (cmbSignatureMethod.getSelectedIndex())
		{
			case 0: return SBXMLSec.xsmDSS;
			case 1: return SBXMLSec.xsmRSA_SHA1;
			case 2: return SBXMLSec.xsmRSA_MD5;
			case 3: return SBXMLSec.xsmRSA_SHA256;
			case 4: return SBXMLSec.xsmRSA_SHA384;
			case 5: return SBXMLSec.xsmRSA_SHA512;
			case 6: return SBXMLSec.xsmRSA_RIPEMD160;
			default: return SBXMLSec.xsmRSA_SHA1;
		}	
	}

	public short getHMACMethod() {
		switch (cmbHMACMethod.getSelectedIndex())
		{
			case 0: return SBXMLSec.xmmHMAC_MD5;
			case 1: return SBXMLSec.xmmHMAC_SHA1;
			case 2: return SBXMLSec.xmmHMAC_SHA224;
			case 3: return SBXMLSec.xmmHMAC_SHA256;
			case 4: return SBXMLSec.xmmHMAC_SHA384;
			case 5: return SBXMLSec.xmmHMAC_SHA512;
			case 6: return SBXMLSec.xmmHMAC_RIPEMD160;
			default: return SBXMLSec.xmmHMAC_SHA1;
		}
	}

	public String getKeyName() {
		return edKeyName.getText();
	}

	public boolean getIncludeKey() {
		return chbIncludeKey.isSelected();
	}

	public String getKeyFile() {
		return edKeyFile.getText();
	}

	public String getPassphrase() {
		return new String(edPassphrase.getPassword());
	}

	public void setCanonicalizationMethod(short value) {
		switch (value)
		{
			case SBXMLDefs.xcmCanon: 
			{
				cmbCanonMethod.setSelectedIndex(0);
				break;
			}
			case SBXMLDefs.xcmCanonComment: 
			{
				cmbCanonMethod.setSelectedIndex(1);
				break;
			}
			case SBXMLDefs.xcmMinCanon: 
			{
				cmbCanonMethod.setSelectedIndex(2);
				break;
			}
			default:
			{
				cmbCanonMethod.setSelectedIndex(0);
				break;
			}
		}		
	}

	public void setSignatureTypeText(String value) {
		cmbSignatureType.setSelectedItem(value);
	}

	public void setSignatureMethodType(short value) {
		if (value == SBXMLSec.xmtMAC)
			rbHMACMethod.setSelected(true);
		else
			rbSignatureMethod.setSelected(true);		
	}

	public void setSigMethod(short value) {
		switch (value)
		{
			case SBXMLSec.xsmDSS: 
			{
				cmbSignatureMethod.setSelectedIndex(0);
				break;
			}
			case SBXMLSec.xsmRSA_SHA1: 
			{
				cmbSignatureMethod.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xsmRSA_MD5: 
			{
				cmbSignatureMethod.setSelectedIndex(2);
				break;
			}
			case SBXMLSec.xsmRSA_SHA256: 
			{
				cmbSignatureMethod.setSelectedIndex(3);
				break;
			}
			case SBXMLSec.xsmRSA_SHA384: 
			{
				cmbSignatureMethod.setSelectedIndex(4);
				break;
			}
			case SBXMLSec.xsmRSA_SHA512: 
			{
				cmbSignatureMethod.setSelectedIndex(5);
				break;
			}
			case SBXMLSec.xsmRSA_RIPEMD160: 
			{
				cmbSignatureMethod.setSelectedIndex(6);
				break;
			}
		}		
	}

	public void setHMACMethod(short value) {
		switch (value)
		{
			case SBXMLSec.xmmHMAC_MD5: 
			{
				cmbHMACMethod.setSelectedIndex(0);
				break;
			}
			case SBXMLSec.xmmHMAC_SHA1: 
			{
				cmbHMACMethod.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xmmHMAC_SHA224: 
			{
				cmbHMACMethod.setSelectedIndex(2);
				break;
			}
			case SBXMLSec.xmmHMAC_SHA256: 
			{
				cmbHMACMethod.setSelectedIndex(3);
				break;
			}
			case SBXMLSec.xmmHMAC_SHA384: 
			{
				cmbHMACMethod.setSelectedIndex(4);
				break;
			}
			case SBXMLSec.xmmHMAC_SHA512: 
			{
				cmbHMACMethod.setSelectedIndex(5);
				break;
			}
			case SBXMLSec.xmmHMAC_RIPEMD160: 
			{
				cmbHMACMethod.setSelectedIndex(6);
				break;
			}
		}
	}

	public void setKeyName(String value) {
		edKeyName.setText(value);
	}

	public void setSignatureType(short value) {
		switch (value)
		{
			case SBXMLSec.xstDetached: 
			{
				cmbSignatureType.setSelectedIndex(2);
				break;
			}
			case SBXMLSec.xstEnveloping: 
			{
				cmbSignatureType.setSelectedIndex(1);
				break;
			}
			case SBXMLSec.xstEnveloped: 
			{
				cmbSignatureType.setSelectedIndex(0);
				break;
			}
		}		
	}

	public void showReferencesDialog() {
		frmReferences.setModal(true);
		frmReferences.setVisible(true);
	}

	public void showXAdESDialog() {
		frmXAdES.setModal(true);
		frmXAdES.setVisible(true);
	}
}